rem Author:  Mark Lang, 1998
rem Name:    access2.sql
rem Purpose: Show objects currently in use in the database
rem Usage:   @access2 <%owner.name%> <%type%> <%username%>
rem Subject: tuning
rem Attrib:  sql dba
rem Descr:
rem Notes:   Groups / counts by object
rem SeeAlso: @access @locks
rem History:
rem          01-feb-98  Initial release

@setup1
define typ="upper('&&2')"
define usr="upper('&&3')"

column oname format a30 heading "OBJECT_NAME"
column cnt format 9,990

select
a.owner||'.'||a.object oname
,a.type
,count(*) cnt
from v$access a, v$session s
where a.sid = s.sid
and s.username like &&usr
and a.owner like &&o1
and a.object like &&n1
and a.type like &&typ
group by a.owner, a.object, a.type
order by a.owner, a.object, a.type;

undef usr typ

@setdefs

