rem Author:  Mark Lang, 1998
rem Name:    args.sql
rem Purpose: Display package function arguments
rem Usage:   @args <%owner.package%> <%object%> <%datatype%>
rem Subject: plsql
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @objs
rem History:
rem          03-feb-98  Add OVERLOAD column to sort
rem          01-feb-98  Initial release

@setup1

define obj="upper('&&2')"
define typ="upper('&&3')"

column pname format a20 wrap
column oname format a20 wrap
column aname format a15 wrap
column data_type format a14
column in_out format a6

select 
owner||'.'||package_name pname
,object_name||decode(overload,null,'','('||overload||')') oname
,argument_name aname
,data_type
,in_out
from all_arguments
where owner like &&o1
and package_name like &&n1
and object_name like &&obj
and (data_type like &&typ or (&&typ='%' and data_type is null))
order by owner,package_name,object_name,overload,position
;

undef obj typ

@setdefs

