rem Author:  Mark Lang, 1998
rem Name:    compat.sql
rem Purpose: Display backward-compatibility specific features
rem Usage:   @compat <%search%>
rem Subject: database
rem Attrib:  sql dba
rem Descr:
rem Notes:   Release 0.0.0.0.0 means feature has not been used
rem SeeAlso: @vers
rem History:
rem          01-feb-98  Initial release

@setup
define src="upper('&&1')"

column release format a14
column description format a50

define v1="instr(release,'.',1,1)"
define v2="instr(release,'.',1,2)"
define v3="instr(release,'.',1,3)"
define v4="instr(release,'.',1,4)"

select
  type_id,
  release,
  description
from v$compatibility
where upper(description) like &&src
order by
  lpad(substr(release, 1, &&v1-1), 2) desc,
  lpad(substr(release, &&v1+1, &&v2-&&v1-1), 2) desc,
  lpad(substr(release, &&v2+1, &&v3-&&v2-1), 2) desc,
  lpad(substr(release, &&v3+1, &&v4-&&v3-1), 2) desc,
  lpad(substr(release, &&v4+1), 2) desc,
  type_id
;

undef src v1 v2 v3 v4

@setdefs

