rem Author:  Mark Lang, 1998
rem Name:    cons.sql
rem Purpose: List constraints
rem Usage:   @cons <%owner.table%> <%constraint%> <%type%>
rem Subject: object:table:constraint
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @cons2 @refs
rem History:
rem          01-feb-98  Added <%constraint%> argument
rem          01-feb-98  Initial release

@setup1
define con="upper('&&2')"
define typ="upper(replace('&&3','%','PURC'))"

column status format a2 heading "SD"
column cname format a30 heading "NAME"
column constraint format a44 WORD heading "CONSTRAINT"

select
  substr(c.status, 1, 1)
  || substr(c.delete_rule, 1, 1) status
  ,c.owner||'.'||c.table_name||'.'||constraint_name cname
  ,decode(c.constraint_type,
    'P', 'PRIMARY KEY ('||&&sqllib..column_list(c.owner, c.constraint_name,'CONSTRAINT')||')',
    'U', 'UNIQUE ('||&&sqllib..column_list(c.owner, c.constraint_name,'CONSTRAINT')||')',
    'C', 'CHECK ('||&&sqllib..scond(c.owner, c.constraint_name)||')',
    'R', 'FOREIGN KEY ('||&&sqllib..column_list(c.owner, c.constraint_name,'CONSTRAINT')||') '||
         'REFERENCES '
         ||&&sqllib..rtable(c.r_owner, c.r_constraint_name)
         ||' ('
         ||&&sqllib..column_list(c.r_owner, c.r_constraint_name,'CONSTRAINT')||')',
    'V', 'CHECK OPTION',
    'UNKNOWN') constraint
from &&ora._constraints c
where c.owner like &&o1 and c.table_name like &&n1
and constraint_name like &&con
and instr(&&typ, c.constraint_type) > 0
order by 1, 2
;

undef con typ

@setdefs

