rem Author:  Mark Lang, 1998
rem Name:    crseq.sql
rem Purpose: Create a sequence based on max value of a column
rem Usage:   @crseq [owner.]sequence table[@db] value
rem Subject: object:sequence
rem Attrib:  gen ddl own
rem Attrib:  sql
rem Descr:
rem Notes:   if using a column use COLUMN+1
rem          if you know the next value then make table DUAL
rem SeeAlso:
rem History:
rem          01-feb-98  Initial release

@setup1
set heading off

spool crseq.tmp

select
  'DROP SEQUENCE &&1;'
from user_sequences
where sequence_name = &&n1
;

select
  'CREATE SEQUENCE &&1 START WITH '||(NVL(MAX(&&3),0)+1)||';'
from &&2
;

select
  'GRANT '||privilege||' ON '||owner||'.'||table_name||' TO '||grantee||
  decode(grantable,'YES',' with grant option')||';'
from user_tab_privs
where owner = &&o1
AND table_name = UPPER('&&1')
;

spool off
@doit
set feedback on
@crseq.tmp
@setdefs

