rem Author:  Mark Lang, 1998
rem Name:    crud.sql
rem Purpose: Display access to tables in CRUD chart by role
rem Usage:   @crud <%owner.object%> <%role%> <%type%>
rem Subject: security
rem Attrib:  sql
rem Descr:
rem Notes:   Does not include inherited grants
rem SeeAlso: @crud2 @privs
rem History:
rem          01-feb-98  Initial release

@setup1

define rol=upper('&&2')
define typ=upper('&&3')

column tname 	   format a30 heading "TABLE"
column grantee     format a15 heading "GRANTEE"
column object_type format a12 heading "TYPE"
column dml         format a5 heading " DML |SIUDX"
column ddl         format a3 heading "DDL|ARN"
column grantable   format a1 heading "G"

select
o.owner||'.'||o.object_name tname
,p.grantee
,max(o.object_type) object_type
,max(decode(p.privilege, 'SELECT', 'S', ' '))
||max(decode(p.privilege, 'INSERT', 'I', ' ')) 
||max(decode(p.privilege, 'UPDATE', 'U', ' '))
||max(decode(p.privilege, 'DELETE', 'D', ' '))
||max(decode(p.privilege, 'EXECUTE', 'X', ' '))
  dml
,max(decode(p.privilege, 'ALTER', 'A', ' '))
||max(decode(p.privilege, 'REFERENCES', 'R', ' '))
||max(decode(p.privilege, 'INDEX', 'N', ' '))
  ddl
,max(decode(p.grantable, 'YES', 'G', ' '))
  grantable
from &&ora._tab_privs p, &&ora._objects o
where o.owner like &&o1
and o.object_name like &&n1
and o.object_type not in ('SYNONYM','INDEX','PACKAGE BODY','TRIGGER') 
and o.object_type like &&typ
and o.object_name = p.table_name(+)
and p.grantee(+) like &&rol
group by o.owner||'.'||o.object_name,p.grantee
;

undef rol typ

@setdefs

