rem Author:  Mark Lang, 1998
rem Name:    crud2.sql
rem Purpose: Display access to tables in CRUD chart by role
rem Usage:   @crud2 <%owner.object%> <%role%>
rem Subject: security
rem Attrib:  sql
rem Descr:
rem Notes:   Does not include inherited grants; like crud but does not group
rem          by role
rem SeeAlso: @crud
rem History:
rem          01-feb-98  Initial release

@setup1

define rol=upper('&&2')

column tname 	 format a30 heading "TABLE"
rem column grantee     format a15 heading "GRANTEE"
column object_type format a12 heading "TYPE"
column crud	       format a4  heading "CRUD"
column dml         format a5  heading " DML |SIUDX"
column ddl         format a3  heading "DDL|AFN"

select
p.owner||'.'||p.table_name tname
--,p.grantee
, max(o.object_type) object_type
, max(decode(p.privilege, 'SELECT', 'S', ' '))
||max(decode(p.privilege, 'INSERT', 'I', ' '))
||max(decode(p.privilege, 'UPDATE', 'U', ' '))
||max(decode(p.privilege, 'DELETE', 'D', ' '))
||max(decode(p.privilege, 'EXECUTE', 'X', ' '))
  dml
, max(decode(p.privilege, 'ALTER', 'A', ' '))
||max(decode(p.privilege, 'REFERENCES', 'F', ' '))
||max(decode(p.privilege, 'INDEX', 'N', ' '))
  ddl
from sys.dba_tab_privs p, sys.dba_objects o
where p.grantee like &&rol
and p.owner like &&o1
and p.table_name like &&n1
and p.table_name = o.object_name(+)
and o.object_type <> 'SYNONYM'
group by p.owner||'.'||p.table_name --,p.grantee
;

undef rol

@setdefs

