rem Author:  Mark Lang, 1998
rem Name:    daily.sql
rem Purpose: Execute a job daily at some specific time
rem Usage:   @daily <time> "<job>"
rem Subject: job
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @jc @jobs @submit
rem History:
rem          01-feb-98  Initial release

@setup

define tim="&&1"
define cmd="'&&2'"

declare
  i number;
  d date;
begin
  d := trunc(sysdate)+&&tim/24;
  if d <= sysdate then
    d := d + 1;
  end if;
  sys.dbms_job.submit(i, &&cmd, d, 'trunc(sysdate+1)+&&tim/24');
  &&putl('Job '||i||' submitted (commit required).');
end;
/

undef tim cmd

@setdefs
