rem Author:  Mark Lang, 1998
rem Name:    dbbegin.sql
rem Purpose: SQL*DBA script to prepare database for ONLINE backup
rem Usage:   @dbbegin
rem Subject: svrmgr
rem Attrib:  mgr
rem Descr:
rem Notes:   Use from SQL*DBA or SVRMGR only
rem SeeAlso: @dbend
rem History:
rem          01-feb-98  Initial release

connect internal

set serveroutput on size 102400

declare

n_cnt binary_integer;

procedure exec(stmt varchar2)
is
  i number;
  retval number;
begin
  sys.dbms_output.put_line(stmt);
  i := sys.dbms_sql.open_cursor;
  sys.dbms_sql.parse(i, stmt, sys.dbms_sql.v7);
  retval := sys.dbms_sql.execute(i);
  sys.dbms_sql.close_cursor(i);
end;

begin
n_cnt:=0;
for r in (
SELECT
ts.tablespace_name tspace
,'alter tablespace '||ts.tablespace_name||' begin backup'
  text
FROM v$database d, sys.dba_tablespaces ts
WHERE d.log_mode = 'ARCHIVELOG'
AND ts.status = 'ONLINE'
AND NOT EXISTS (
  SELECT 0
  FROM v$backup b
  WHERE status = 'ACTIVE'
  AND EXISTS (
    SELECT 0
    FROM sys.dba_data_files
    WHERE file_id = b.file#
    AND tablespace_name = ts.tablespace_name
  )
)) loop
  exec(r.text);
  n_cnt:=n_cnt+1;
end loop;
sys.dbms_output.put_line(to_char(n_cnt)||' tablespace(s) put in online backup mode');
end;
/


