rem Author:  Mark Lang, 1998
rem Name:    dbend.sql
rem Purpose: SQL*DBA script to take database out of ONLINE backup mode
rem Usage:   @dbend
rem Subject: svrmgr
rem Attrib:  mgr
rem Descr:
rem Notes:   Run from SQL*DBA or SVRMGR only
rem SeeAlso: @dbbegin
rem History:
rem          01-feb-98  Initial release


connect internal

set serveroutput on size 102400

declare

n_cnt binary_integer;
v_text varchar2(255);

procedure exec(stmt varchar2)
is
  i number;
  retval number;
begin
  sys.dbms_output.put_line(stmt);
  i := sys.dbms_sql.open_cursor;
  sys.dbms_sql.parse(i, stmt, sys.dbms_sql.v7);
  retval := sys.dbms_sql.execute(i);
  sys.dbms_sql.close_cursor(i);
end;

begin
n_cnt:=0;
for r in (
SELECT
ts.tablespace_name tspace
, 'alter tablespace '||ts.tablespace_name||' end backup'
    text
FROM v$database d, sys.dba_tablespaces ts
WHERE d.log_mode = 'ARCHIVELOG'
AND ts.status = 'ONLINE'
AND EXISTS (
  SELECT 0
  FROM v$backup b
  WHERE status = 'ACTIVE'
  AND EXISTS (
    SELECT 0
    FROM sys.dba_data_files
    WHERE file_id = b.file#
    AND tablespace_name = ts.tablespace_name
  )
)) loop
  exec(r.text);
  n_cnt:=n_cnt+1;
end loop;

if n_cnt>0 then
  v_text:='alter system switch logfile';
  exec(v_text);
  v_text:='alter database backup controlfile to trace';
  exec(v_text);
  select
  'alter database backup controlfile to ''/apps/oracle/admin/'||name||
     '/arch/'||name||to_char(sysdate,'MMDD')||'.con'' reuse'
  into v_text
  from v$database;
  exec(v_text);
end if;
sys.dbms_output.put_line(to_char(n_cnt)||' tablespace(s) restored');
end;
/



