rem Author:  Mark Lang, 1998
rem Name:    dbsize.sql
rem Purpose: Display database size indicators
rem Usage:   @dbsize
rem Subject: database
rem Attrib:  sql dba n80
rem Descr:
rem Notes:
rem SeeAlso: @frag @ratio
rem History:
rem          01-feb-98  Initial release


@setup
define db=""

define l="30"

column sort1 noprint
column text format a50 heading "DATABASE SIZING INDICATORS"

select
  0 sort1, rpad('Database name',&&l)||name text
from v$database&&db
union
select
  1, rpad('Devices used',&&l)||ltrim(to_char(
    count(distinct substr(name, 1,
      least(decode(instr(name,'/',2),0,length(name),instr(name,'/',2)),
            decode(instr(name,'\',2),0,length(name),instr(name,'\',2)),
            decode(instr(name,':',2),0,length(name),instr(name,':',2))
    ))), 
    '990'))
from v$datafile&&db
union
select 
  2, rpad('Datafiles',&&l)||ltrim(to_char(count(*), '9,990'))
from v$datafile&&db
union
select
  3, rpad('Total size (G)',&&l)||ltrim(to_char(sum(bytes)/(1024*1024*1024),
     '990.99'))
from v$datafile&&db
union
select
  4, rpad('Tables and indexes',&&l)||
     ltrim(to_char(sum(decode(type,2,1,0)),'999,990'))||'/'||
     ltrim(to_char(sum(decode(type,1,1,0)),'999,990'))
from sys.obj$&&db
where owner# <> 0 
union
select
  5, rpad('Users',&&l)||ltrim(to_char(count(*),'9,990'))
from sys.user$&&db
where type = 1
union
select
  6, rpad('Sessions highwater',&&l)||
     ltrim(to_char(sessions_highwater,'9,990'))
from v$license&&db
union
select
  9, rpad('SGA (M)',&&l)||ltrim(to_char(sum(value)/(1024*1024),'99,990.99'))
from v$sga&&db
;

undef db l

@setdefs

