rem Author:  Mark Lang, 1998
rem Name:    deps.sql
rem Purpose: Show dependencies
rem Usage:   @deps <%owner.table%> <%ref_owner.ref_table%>
rem Subject: object:dependency
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @deptree
rem History:
rem          01-feb-98  Initial release

@setup2

column oname format a24 heading 'OBJECT NAME'
column otype format a12 heading 'OBJECT TYPE'
column rname format a28 heading 'REFERENCED OBJECT'
column rtype format a12 heading 'REFOBJ TYPE'

select
  owner||'.'||name  oname,
  type otype,
  referenced_owner||'.'||referenced_name||
    decode(referenced_link_name, null, '', '@'||referenced_link_name)
    rname,
  referenced_type rtype
from sys.dba_dependencies
where owner like &&o1 and name like &&n1
and referenced_owner like &&o2 and referenced_name like &&n2
order by 1, 3
;

@setdefs



