rem Author:  Mark Lang, 1998
rem Name:    disablec.sql
rem Purpose: Disables integrity constraints
rem Usage:   @disablec <%owner.table%> <%constraint%> <type|%>[*]
rem Subject: object:table:constraint
rem Attrib:  sql gen ddl
rem Descr:
rem Notes:   Append asterisk to cascade
rem SeeAlso: @cons @disablek @enablec
rem History:
rem          25-mar-98  Added constraint name as 2nd parameter
rem          01-feb-98  Initial release

@setup1
define con="upper('&&2')"
define typ="replace(replace(upper('&&3'), '%', 'PUCR'),'*')"
define cas="decode(sign(instr('&&3','*')),1,' cascade','')"
set heading off

spool disablec.tmp
select
  'alter table '||c.owner||'.'||c.table_name||&&cr||
  'disable constraint '||c.constraint_name||&&cas||';'
from &&ora._constraints c
where c.owner <> 'SYS'
and c.owner like &&o1
and c.table_name like &&n1
and c.constraint_name like &&con
and instr(&&typ, c.constraint_type) > 0
and status = 'ENABLED'
order by c.owner, c.table_name,
  decode(c.constraint_type, 'P', 1, 'U', 2, 'C', 3, 'R', 4, 5),
  c.constraint_name
;
spool off
@doit
set feedback on
@disablec.tmp

undef typ cas

@setdefs
