rem Author:  Mark Lang, 1998
rem Name:    disabled.sql
rem Purpose: Display disabled constraints and triggers
rem Usage:   @disabled <%owner.table%>
rem Subject: object
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @cons2 @invalid @trigs2
rem History:
rem          01-feb-98  Initial release
rem          21-jan-98  Specify object type

@setup1

column oname format a25 heading "OBJECT_NAME"
column constraint_name format a25
column otype format a10 heading "OBJECT_TYPE"

select
owner||'.'||table_name oname
, constraint_name
, 'CONSTRAINT' otype
from &&ora._constraints
where owner like &&o1
and table_name like &&n1
and status='DISABLED'
union all
select
owner||'.'||table_name oname
, trigger_name
, 'TRIGGER' otype
from &&ora._triggers
where owner like &&o1
and table_name like &&n1
and status='DISABLED'
order by 1,2
;

@setdefs
