rem Author:  Mark Lang, 1998
rem Name:    disablek.sql
rem Purpose: Disables integrity constraints
rem Usage:   @disablek <%owner.table%> <type|%> <%column%>
rem Subject: object:table:constraint
rem Attrib:  sql gen ddl
rem Descr:
rem Notes:
rem SeeAlso: @disablec
rem History:
rem          01-feb-98  Initial release

@setup1
set heading off
define typ="replace(REPLACE(UPPER('&&2'), '%', 'PUCR'),'*')"
define cas="decode(sign(instr('&&2','*')),1,' cascade','')"
define col="upper('&&3')"

SPOOL disablek.tmp
SELECT
  'ALTER TABLE '||c.owner||'.'||c.table_name||&&cr||
  'DISABLE CONSTRAINT '||c.constraint_name||&&cas||';'
FROM &&ora._constraints c
WHERE c.owner <> 'SYS'
AND c.owner LIKE &&o1
AND c.table_name LIKE &&n1
AND INSTR(&&typ, c.constraint_type) > 0
AND status = 'ENABLED'
and exists (
  select 0
  from &&ora._cons_columns
  where owner=c.owner
  and constraint_name=c.constraint_name
  and column_name like &&col
)
ORDER BY c.owner, c.table_name,
  DECODE(c.constraint_type, 'P', 1, 'U', 2, 'C', 3, 'R', 4, 5),
  c.constraint_name
;
SPOOL OFF
@doit
SET FEEDBACK ON
@disablek.tmp

undef typ cas col

@setdefs
