rem Author:  Mark Lang, 1998
rem Name:    dropc.sql
rem Purpose: Drop integrity constraints
rem Usage:   @dropc <%owner.table%> <type|%>[*]
rem Subject: object:table:constraint
rem Attrib:  sql gen ddl
rem Descr:
rem Notes:   * in 2nd argument causes CASCADE
rem SeeAlso: @disablec @drop
rem History:
rem          01-feb-98  Initial release


@setup1
define typ="replace(REPLACE(UPPER('&&2'), '%', 'PUCR'),'*')"
define cas="decode(sign(instr('&&2','*')),1,' cascade','')"
set heading off

spool dropc.tmp
select
  'alter table '||c.owner||'.'||c.table_name||&&cr||
  'drop constraint '||c.constraint_name||&&cas||';'
from &&ora._constraints c
where c.owner <> 'SYS'
and c.owner like &&o1
and c.table_name like &&n1
and instr(&&typ, c.constraint_type) > 0
order by c.owner, c.table_name,
  decode(c.constraint_type, 'P', 1, 'U', 2, 'C', 3, 'R', 4, 5),
  c.constraint_name
;
spool off
@doit
set feedback on
@dropc.tmp

undef typ cas

@setdefs

