rem Author:  Mark Lang, 1998
rem Name:    dropi.sql
rem Purpose: Drop indexes on the selected tables
rem Usage:   @dropi <%owner.table%> <%index%> <%uniq%>
rem Subject: object:table:index
rem Attrib:  sql gen ddl
rem Descr:
rem Notes:
rem SeeAlso: @drop @idxs @segsi
rem History:
rem          01-feb-98  Initial release

@setup1
set heading off
define idx="upper('&&2')"
define typ="upper('&&3')"

spool dropi.tmp
select
  'DROP INDEX '||i.owner||'.'||i.index_name||';'
from &&ora._indexes i
where i.table_owner like &&o1
and i.table_name like &&n1
and i.owner <> 'SYS'
and i.index_name like &&idx
and i.uniqueness like &&typ
and not exists (
  select 0
  from &&ora._constraints
  where owner = i.table_owner
  and index_name = constraint_name
  and constraint_type in ('P','U')
)
order by i.table_owner, i.table_name, i.index_name
;
spool off
@doit
set feedback on
@dropi.tmp

undef idx typ

@setdefs


