rem Author:  Mark Lang, 1998
rem Name:    dropu.sql
rem Purpose: Drop users
rem Usage:   @dropu <%user%> <%has_role%>
rem Subject: user
rem Attrib:  sql
rem Descr:
rem Notes:   Ignores SYS and SYSTEM
rem SeeAlso:
rem History:
rem          01-feb-98  Initial release

@setup
set heading off

define usr="upper('&&1')"
define rol="upper('&&2')"

spool dropu.tmp

select
'drop user '||u.username||' cascade;'
from sys.dba_users u
where u.username not in ('SYS','SYSTEM')
and u.username like &&usr
and (
  &&rol='%'
  or exists (
    select 0
    from sys.dba_role_privs
    where grantee=u.username
    and granted_role like &&rol
  )
);

spool off
@doit
set feedback on
@dropu.tmp

undef rol usr

@setdefs

