rem Author:  Mark Lang, 1998
rem Name:    dumpu.sql
rem Purpose: Dump user definitions
rem Usage:   @dumpu <%username%>
rem Subject: user
rem Attrib:  sql
rem Descr:
rem Notes:   Useful recreating databases from exports
rem SeeAlso:
rem History:


@setup
set heading off
SPOOL dumpu.tmp

rem CREATE USERS

select
  'create user '||username||' identified by values '''||password||''''||&&cr||
  'default tablespace '||default_tablespace||&&cr||
  'temporary tablespace '||temporary_tablespace||';'
from sys.dba_users
where username not in (&&sysusers)
order by username;

rem CREATE ROLES

select
  'create role '||role||';'
from sys.dba_roles
where role not in (&&sysroles)
order by role
;

rem GRANT SYSTEM PRIVILEGES

select
  'grant '||privilege||' to '||grantee||
  decode(admin_option, 'yes', ' with admin option', '')||
  ';'
from sys.dba_sys_privs
where grantee not in (&&sysusers)
order by grantee, privilege
;

rem GRANT ROLE PRIVILIGES

select
  'grant '||granted_role||' to '||grantee||
  decode(admin_option, 'yes', ' with admin option', '')||
  ';'
from sys.dba_role_privs
where grantee not in (&&sysusers)
order by grantee, granted_role
;

rem SET DEFAULT ROLES

select
  'alter user '||username||' default role '||df.privs(username,'defrole')||';'
from sys.dba_users
where username not in (&&sysusers)
order by username
;

spool off

@setdefs


