rem Author:  Mark Lang, 1998
rem Name:    enablec.sql
rem Purpose: Enables integrity constraints
rem Usage:   @enablec <%owner.table%> <%constraint%> <type|%> <exception_table|*>
rem Subject: object:table:constraint
rem Attrib:  sql gen ddl
rem Descr:
rem Notes:
rem SeeAlso: @disablec
rem History:
rem
rem          25-mar-98  Add constraint name as 2nd parameter
rem          01-feb-98  Initial release

@setup1
deinfe con="upper('&&2')"
define typ="replace(upper('&&3'), '%', 'PURC')"
define exc="upper('&&4')"

SET HEADING OFF

SPOOL enablec.tmp
SELECT
  'ALTER TABLE '||c.owner||'.'||c.table_name||&&cr||
  'ENABLE CONSTRAINT '||c.constraint_name||
  decode(&&exc,'*','',' exceptions into '||
    decode(&&exc,'?','exceptions',&&exc))||
  ';'
FROM &&ora._constraints c
WHERE c.owner <> 'SYS'
AND c.owner LIKE &&o1
AND c.table_name LIKE &&n1
and c.constraint_name like &&con
AND INSTR(&&typ, c.constraint_type) > 0
AND status != 'ENABLED'
ORDER BY c.owner, c.table_name,
  DECODE(c.constraint_type, 'P', 1, 'U', 2, 'C', 3, 'R', 4, 5),
  c.constraint_name
;
SPOOL OFF
@doit
SET FEEDBACK ON
@enablec.tmp

undef typ exc

@setdefs
