rem Author:  Mark Lang, 1998
rem Name:    enforce.sql
rem Purpose: Enable NOVALIDATE integrity constraints, then enable
rem Usage:   @enforce <%owner.table%> <type|%> <*|exc_table>
rem Subject: object:table:constraint
rem Attrib:  sql gen ddl
rem Descr:
rem Notes:
rem SeeAlso: @enablec
rem History:
rem          01-feb-98  Initial release
rem          21-jan-98  Created

@setup1
define typ="REPLACE(UPPER('&&2'), '%', 'PUCR')"
define exc="upper('&&3')"

set heading off
spool enforce.tmp

select
  'alter table '||c.owner||'.'||c.table_name||&&cr||
  'enforce constraint '||c.constraint_name
  ||';'
from &&ora._constraints c
where c.owner <> 'sys'
and c.owner like &&o1
and c.table_name like &&n1
and instr(&&typ, c.constraint_type) > 0
and status != 'enabled'
order by c.owner, c.table_name,
  decode(c.constraint_type, 'p', 1, 'u', 2, 'c', 3, 'r', 4, 5),
  c.constraint_name
;

select
  'alter table '||c.owner||'.'||c.table_name||&&cr||
  'enable constraint '||c.constraint_name||
  decode(&&exc,'*','',' exceptions into '||
    decode(&&exc,'?','exceptions',&&exc))||';'
from &&ora._constraints c
where c.owner <> 'sys'
and c.owner like &&o1
and c.table_name like &&n1
and instr(&&typ, c.constraint_type) > 0
and validated != 'VALIDATED'
order by c.owner, c.table_name,
  decode(c.constraint_type, 'p', 1, 'u', 2, 'c', 3, 'r', 4, 5),
  c.constraint_name
;

spool off
@doit
set feedback on
@enforce.tmp

undef typ exc

@setdefs
