rem Author:  Mark Lang, 1998
rem Name:    errors.sql
rem Purpose: Show errors on a stored object
rem Usage:   @errors %[owner.]object%
rem Subject: plsql
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @list
rem History:
rem          01-feb-98  Initial release

@setup1
set heading off

set term off
select * from dual;
set term on

column linepos format a8  heading "Line/Pos"
column text    format a70 heading "Description" word

set heading on
select
  to_char(e.line)||'/'||to_char(e.position) linepos,
  e.text
from all_errors e
where e.owner like &&o1
and   e.name  like &&n1
order by e.owner, e.name, e.sequence
;
set heading off


select
  'Object does not exist.'
from dual
where not exists
  (select * from all_objects
   where owner like &&o1
   and   object_name  like &&n1
  )
;

select
  'No errors.'
from dual
where exists
  (select * from all_objects
   where owner like &&o1
   and   object_name  like &&n1
  ) and
  not exists
  (select * from all_errors
   where owner like &&o1
   and   name  like &&n1
  )
;

@setdefs

