rem Author:  Mark Lang, 1998
rem Name:    estimate.sql
rem Purpose: Perform ANALYZE TABLE on multiple tables
rem Usage:   @estimate <%owner.table%> <*|percent|rows>
rem Subject: object:table
rem Attrib:  sql gen ddl
rem Descr:
rem Notes:   if arg2<100 then asumme PERCENT else assume ROWS
rem SeeAlso: @analyze
rem History:
rem          01-feb-98  Initial release

@setup1
set heading off

define per="decode('&&2',null,'','*','','%','','0','',' sample &&2 '||decode(sign(to_number('&&2')-100),1,'rows','percent'))"

spool estimate.tmp

select
  'prompt Analyzing '||o.owner||'.'||o.object_name||'...'||&&cr||  
  'analyze '||o.object_type||' '||o.owner||'.'||o.object_name||&&cr||
  'estimate statistics for table'||&&per||';'||&&cr||
  'analyze '||o.object_type||' '||o.owner||'.'||o.object_name||&&cr||
  'estimate statistics for all indexes'||&&per||';'||&&cr||
  'analyze '||o.object_type||' '||o.owner||'.'||o.object_name||&&cr||
  'estimate statistics for all indexed columns'||&&per||';'
from &&ora._objects o 
where o.owner not in ('SYS','SYSTEM')
and o.owner like &&o1
and o.object_name like &&n1
and o.object_type = 'TABLE'
order by o.owner, o.object_name
;

spool off
@doit
set feedback on
@estimate.tmp

undef per

@setdefs





