rem Author:  Mark Lang, 1998
rem Name:    estown.sql
rem Purpose: Estimate objects in a schema
rem Usage:   @estown <owner> <sample|%>
rem Subject: object:table
rem Attrib:  sql ddl
rem Descr:
rem Notes:   If sample is 0 or % then use default sample size
rem          otherwise
rem SeeAlso: @estimate
rem History:
rem          01-feb-98  Initial release

@setup
define usr="upper('&&1')"
define sam="to_number(replace('&&2','%','0'))"

declare
  i binary_integer;
  sam number;
  row number;
  pct number;
  txt varchar2(30);
  opt varchar2(60);
  tim varchar2(30);
  t1 number;
  t2 number;
begin
  sam := &&sam;
  if sam > 100 then
    row := sam;
    txt := 'rows';
  elsif sam > 0 then
    pct := sam;
    txt := '%';
  end if;

  for i in 1..3 loop
    if i = 1 then opt := 'for table';
    elsif i = 2 then opt := 'for all indexes';
    else opt := 'for all indexed columns';
    end if;
    t1 := sys.dbms_utility.get_time;
    sys.dbms_utility.analyze_schema(
      schema=>upper('&&1')
    , method=>'ESTIMATE'
    , estimate_rows=>row
    , estimate_percent=>pct
    , method_opt=>opt
    );
    t2 := sys.dbms_utility.get_time;
    tim := ' ('||ltrim(to_char((t2-t1)/(100*60),'990.90'))||'m)';
    if sam > 0 then
     &&putl('Estimate '||opt||' ('||to_char(sam)||' '||txt||') on '||&&usr||tim);
    else
      &&putl('Estimate '||opt||' on '||&&usr||tim);
    end if;
  end loop;
end;
/

undef usr sam

@setdefs



