rem Author:  Mark Lang, 1998
rem Name:    expl.sql
rem Purpose: Does structured display of EXPLAIN PLAN
rem Usage:   @expl <explain_id>
rem Subject: tuning
rem Attrib:  sql
rem Descr:
rem Notes:   Like explain.sql but shows plan_text only with full 80 char
rem SeeAlso: @explain
rem History:
rem          01-feb-98  Initial release

@setup
column query_plan format a75

SELECT
  DECODE(id, 0, '', LPAD(' ',2*(level-1))||level||'.'||position||' ')
  ||operation
  ||decode(options,null,'',' ('||options||')')
  ||' '||object_name  
  ||' '||decode(id, 0, 'Cost = '||position) query_plan
FROM plan_table
START WITH id = 0
AND statement_id = '&&1'
CONNECT BY prior id = parent_id
AND statement_id = '&&1';

@setdefs

