rem Author:  Mark Lang, 1998
rem Name:    explain.sql
rem Purpose: Does structured display of EXPLAIN PLAN
rem Usage:   @explain <explain_id> <long>
rem Subject: tuning
rem Attrib:  sql
rem Descr:
rem Notes:   Must run AFTER doing the EXPLAIN PLAN command
rem SeeAlso: @expl @explcnt @explsel @explstat
rem History:
rem          01-feb-98  Initial release

@setup
set long &&2 
column query_plan format a40
column object_node format a10
column parl format a4
column text format a23 word 

SELECT
  DECODE(id, 0, '', LPAD(' ',2*(level-1))||level||'.'||position||' ')
  ||operation
  ||decode(options,null,'',' ('||options||')')
  ||' '||object_name  
  ||' '||decode(id, 0, 'Cost = '||position) query_plan,
  object_node,
  decode(other_tag,
    'SERIAL', 'S',
    'SERIAL_FROM_remOTE', 'SFR',
    'PARALLEL_COMBINED_WITH_PARENT', 'PCWP',
    'PARALLEL_COMBINED_WITH_CHILD', 'PCWC',
    'PARALLEL_TO_SERIAL', 'PTS',
    'PARALLEL_TO_PARALLEL', 'PTP',
    'PARALLEL_FROM_SERIAL', 'PFS'
  ) parl,
  other text
FROM plan_table
START WITH id = 0
AND statement_id = '&&1'
CONNECT BY prior id = parent_id
AND statement_id = '&&1';

@setdefs

