rem Author:  Mark Lang, 1998
rem Name:    explstat.sql
rem Purpose: Does structured display of EXPLAIN PLAN
rem Usage:   @explstat <explain_id>
rem Subject: tuning
rem Attrib:  sql
rem Descr:
rem Notes:   Must run AFTER doing the EXPLAIN PLAN command
rem SeeAlso: @explain
rem History:
rem          01-feb-98  Initial release

@setup
column query_plan format a35
column object_node format a10
column position format 9,990 heading "POS"
column cost format 9,990 heading "COST"
column cardinality format 999,990 heading "ROWS"
column bytes format 999,990 heading "BYTES"

SELECT
  DECODE(id, 0, '', LPAD(' ',2*(level-1))||level||'.'||position||' ')
  ||operation||' '||options||' '||object_name||' '||other_tag
  ||' '||decode(id, 0, 'Cost = '||position) query_plan,
  object_node,
  position,
  cost,
  cardinality,
  bytes
FROM plan_table
START WITH id = 0
AND statement_id = '&&1'
CONNECT BY prior id = parent_id
AND statement_id = '&&1';

@setdefs

