rem Author:  Mark Lang, 1998
rem Name:    exts.sql
rem Purpose: List segment extents
rem Usage:   @exts <%owner.segment%> <tablespace> <min_extent>
rem Subject: space
rem Attrib:  sql dba
rem Descr:
rem Notes:
rem SeeAlso: @segs
rem History:
rem          01-feb-98  Initial release

@setup1
define ts ="upper('&&2')"
define siz="decode('&&3','%','0','&&3')"

column sname format A30 heading 'SEGMENT_NAME'
column segment_type format A8  heading 'TYPE'
column tablespace_name format A12 heading 'TABLESPACE'
column block_id format 99,990
column blocks format 999,990
column extent_id format 999 heading 'EXT'
column contig format a1

select
  e.owner||'.'||e.segment_name sname, 
  e.segment_type, 
  e.tablespace_name,
  e.block_id,
  e.blocks,
  e.extent_id,
  decode(ec.blocks, null, ' ', 'Y') contig
from sys.dba_extents e, sys.dba_extents ec
where e.owner like &&o1
and e.segment_name like &&n1
and e.tablespace_name like &&ts
and e.extent_id >= to_number(&&siz)
and e.owner = ec.owner(+)
and e.segment_name = ec.segment_name(+)
and e.tablespace_name = ec.tablespace_name(+) 
and e.file_id = ec.file_id(+)
and e.extent_id = ec.extent_id(+) + 1
and e.block_id = ec.block_id(+) + ec.blocks(+)
order by e.owner, e.segment_name, e.extent_id
;

undef ts siz

@setdefs







