rem Author:  Mark Lang, 1998
rem Name:    files.sql
rem Purpose: Display datafiles
rem Usage:   @files <%file_name%> <%tablespace%> <%status%>
rem Subject: database
rem Attrib:  sql dba
rem Descr:
rem Notes:
rem SeeAlso: @frag @ts
rem History:
rem          01-feb-98  Initial release

@setup

define fn="'&&1'"
define ts="upper('&&2')"
define st="upper('&&3')"

column file_id format 90 heading "F#"
column file_name format a30 wrap
column tablespace_name format a14 wrap
column mbytes format 9,990 heading "MB"
column maxext format 9,990 heading "MAXEX"
column next   format 990 heading "NEXT"
column status format a9

select
file_id
,file_name
,tablespace_name
,bytes/(1024*1024) mbytes
,maxextend/(1024*1024) maxext
,inc/(1024*1024) next
,status
from sys.dba_data_files f, sys.filext$ x
where file_name like &&fn
and tablespace_name like &&ts
and status like &&st
and file_id=x.file#(+)
;

undef fn ts st

@setdefs

