rem Author:  Mark Lang, 1998
rem Name:    filext.sql
rem Purpose: Show datafile AUTOEXTEND characteristics
rem Usage:   @filext <%file_name%>
rem Subject: database
rem Attrib:  sql dba v72
rem Descr:
rem Notes:
rem SeeAlso: @files @frag
rem History:
rem          01-feb-98  Initial release

@setup

define nam="'&&1'"

column file# format 90
column name format a35 wrap
column maxext format 999,990 heading "MAXEXT(M)"
column inc format 999,990 heading "INC(M)"
column blocks format 9,999,990 heading "BLOCKS(M)"
column used format 0.999

define maxext="(x.maxextend*t.blocksize/(1024*1024))"
define inc="(x.inc*t.blocksize/(1024*1024))"
define blocks="(f.blocks*t.blocksize/(1024*1024))"

select
v.file#
,v.name
,&&maxext maxext
,&&inc inc
,&&blocks blocks
,decode(x.maxextend,null,0,0,0,f.blocks/nvl(x.maxextend,0)) used
from sys.filext$ x, v$dbfile v, sys.file$ f, sys.ts$ t
where f.file#=v.file#
and f.file#=x.file#
and f.ts#=t.ts#
and v.name like &&nam
;

undef nam

@setdefs

