rem Author:  Mark Lang, 1998
rem Name:    forobjs.sql
rem Purpose: Performs "command" on each object
rem Usage:   @forobjs <%owner.table%> <%type%> <%tspace%> <%role%> "<command>"
rem Subject: misc
rem Attrib:  sql gen
rem Descr:
rem Notes:   Use with caution
rem          Executes <command> for each object matched--substitutions to
rem          <command> are made as follows:
rem
rem		{o}	owner
rem		{n}	object_name
rem		{y}	object_type
rem
rem SeeAlso: @all @apply
rem History:

@setup1
set heading off

define ty="upper('&&2')"
define ts="upper('&&3')"
define rl="upper('&&4')"
define cm="'&&5'"

spool forobjs.tmp
select
  replace(replace(replace(&&cm, '{o}', o.owner), '{n}', o.object_name),
    '{y}', o.object_type) text
from sys.dba_objects o, sys.dba_segments s
where o.owner like &&o1
and o.object_name like &&n1
and o.object_type like &&ty
and o.object_type not in ('PACKAGE BODY')
and o.owner = s.owner and o.object_name = s.segment_name(+)
and (s.segment_name is null or s.tablespace_name like &&ts)
and (&&rl = '%'
  or exists (
    select *
    from sys.dba_tab_privs
    where owner = o.owner
    and table_name = o.object_name
    and grantee like &&rl
  )
)
order by o.owner, o.object_name
;
SPOOL OFF

SET FEEDBACK ON
@doit
@forobjs.tmp

undef ty ts rl cm

@setdefs

