rem Author:  Mark Lang, 1998
rem Name:    frag.sql
rem Purpose: Displays database fragmentation
rem Usage:   @frag <%ts%> <max_free|%>
rem Subject: space
rem Attrib:  sql dba
rem Descr:
rem Notes:
rem SeeAlso: @segs @space
rem History:
rem          01-feb-98  Initial release
rem          14-jan-98  Added support for min_free parameter

@setup
set serveroutput on size 10240

define db=""
define ts="upper('&&1')"
define fr="to_number(replace('&&2','%','0'))"

prompt

declare
  dbnm    varchar2(8);
  files   number;
  sizem   number;
  freem   number;
  pctf    number;
  pieces  number;
  biggest number;
  lt100k  number;
  dead    number;
  mexts   number;
  nsegs   number;
  gt10e   number;
  gt100e  number;
  moste	  number;
begin

  select
    name
  into dbnm
  from v$database&&db;

  &&putl('FREE SPACE - '||RPAD(dbnm,8)||' +------------- FREE ------------+ +------  USED ------+');
  &&putl('Tspace       Fl SizeM FreeM %Fre Piecs BigsM <100k Dead NmSegs >10e >100 Most');
  &&putl('------------ -- ----- ----- ---- ----- ----- ----- ---- ------ ---- ---- ----');

  for r in (
    select *
    from sys.ts$&&db
    where online$ = 1
    and name like &&ts
    order by name
  ) loop

     select
       count(*),
       sum(blocks)*r.blocksize
     into files, sizem
     from sys.file$&&db fl, v$dbfile vf
     where fl.ts# = r.ts#
     and fl.file# = vf.file#;	-- make sure dropped files don't show

     select
       sum(length)*r.blocksize,
       decode(sum(length), 0, 100, sum(length)*r.blocksize*100/sizem),
       count(*),
       max(length)*r.blocksize,
       sum(decode(sign(length*r.blocksize-100*1024), 1, 0, 1)),
       sum(decode(sign(length-5), 1, 0, 1))
     into freem, pctf, pieces, biggest, lt100k, dead
     from sys.fet$&&db fs
     where fs.ts# = r.ts#;

     if &&fr = 0 or pctf <= &&fr then
       select
         sum(count(*)),
         sum(decode(sign(max(ext#)-10), -1, 0, 1)),
         sum(decode(sign(max(ext#)-100), -1, 0, 1)),
         max(max(ext#))
       into nsegs, gt10e, gt100e, moste
       from sys.uet$&&db us
       where us.ts# = r.ts#
       group by segfile#, segblock#;

       dbms_output.put_line(
         rpad(r.name, 12)||' '||
         lpad(ltrim(to_char(files, '99')), 2)||' '||
         lpad(ltrim(to_char(sizem/(1024*1024), '9,990')), 5)||' '||
         lpad(ltrim(to_char(freem/(1024*1024), '9,990')), 5)||' '||
         lpad(ltrim(to_char(pctf, '990'))||'%', 4)||' '||
         lpad(ltrim(to_char(pieces, '9,990')), 5)||' '||
         lpad(ltrim(to_char(biggest/(1024*1024), '9,990')), 5)||' '||
         lpad(ltrim(to_char(lt100k, '9,990')), 5)||' '||
         lpad(ltrim(to_char(dead, '9990')), 4)||' '||
         lpad(ltrim(to_char(nsegs, '99,990')), 6)||' '||
         lpad(ltrim(to_char(gt10e, '9990')), 4)||' '||
         lpad(ltrim(to_char(gt100e, '9990')), 4)||' '||
         lpad(ltrim(to_char(moste, '990')), 4)
       );
     end if;
  end loop;

end;
/

undef db fr ts

@setdefs

