rem Author:  Mark Lang, 1998
rem Name:    grobj.sql
rem Purpose: Grant names on an object
rem Usage:   @grobj <priv[*]> <%owner.object%> <%type%> <user|role>
rem Subject: security
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @crud @privs
rem History:
rem          05-feb-98  Initial release

@setup2
set heading off

define prv="upper(replace('&&1','*'))"
define grt="decode(substr('&&1',length('&&1'),1),'*','YES','NO')"
define typ="upper('&&3')"
define usr="upper('&&4')"

spool grobj.tmp
select
  'grant '||p.name||
  ' on '||o.owner||'.'||o.object_name||' to '||u.name||
  decode(&&grt,'YES',' with grant option','')||
  ';'
from sys.dba_objects o, sys.user$ u, table_privilege_map p
where u.name=&&usr
and o.owner like &&o2
and o.object_name like &&n2
and o.object_type like &&typ
and o.object_type not in ('SYNONYM','INDEX','TRIGGER','PACKAGE BODY',
  'DATABASE LINK')
and p.name in ('SELECT','INSERT','UPDATE','DELETE','EXECUTE',
  'ALTER','INDEX','REFERENCES')
and (
  p.name like &&prv
  or (&&prv='READ' and p.name in ('SELECT','EXECUTE'))
  or (&&prv='WRITE' and p.name in ('SELECT','INSERT','UPDATE','DELETE',
    'EXECUTE'))
  or &&prv='ALL'
)
and (p.name not in ('INSERT','UPDATE','DELETE') or o.object_type in 
  ('TABLE','VIEW'))
and (p.name not in ('INDEX','REFERENCES') or o.object_type = 'TABLE')
and (p.name != 'EXECUTE' or o.object_type in ('FUNCTION','PROCEDURE',
  'PACKAGE'))
and not exists (
  select 0
  from sys.dba_tab_privs
  where grantee=u.name
  and owner=o.owner
  and table_name=o.object_name
  and privilege=p.name
  and (
    &&grt='NO'
    or grantable='YES'
  )
)
order by o.owner, o.object_name
;
spool off

@doit
set feedback on
@grobj.tmp

undef prv grt typ usr
@setdefs
