rem Author:  Mark Lang, 1998
rem Name:    grsys.sql
rem Purpose: Grants select on sys tables
rem Usage:   @grsys <%object%> <user>
rem Subject: security
rem Attrib:  sql gen ddl sys
rem Descr:   Grante SELECT WITH GRANT OPTION to users
rem Notes:   USE WITH CAUTION
rem SeeAlso: @grobj
rem History:
rem          01-feb-98  Initial release

@setup
set heading off
define obj="upper('&&1')"
define usr="NVL(UPPER('&&2'), 'PUBLIC')"

spool grsys.tmp
SELECT
  'GRANT '||
  DECODE(o.object_type, 
   'PROCEDURE', 'EXECUTE',
   'FUNCTION', 'EXECUTE',
   'PACKAGE', 'EXECUTE',
   'SELECT'
  )||' ON sys.'||o.object_name||' TO '||&&usr||&&cr||
  'WITH GRANT OPTION;'
FROM sys.dba_objects o
WHERE user='SYS'
and o.owner = 'SYS'
and o.object_name like upper('&&1')
AND o.object_type IN ('TABLE', 'VIEW', 'PROCEDURE', 'FUNCTION', 'PACKAGE')
AND EXISTS (
  SELECT name
  FROM sys.user$
  WHERE name = &&usr
)
AND NOT EXISTS (
    SELECT * FROM sys.dba_tab_privs
    WHERE
      grantee = &&usr AND
      owner = 'SYS' AND
      table_name = o.object_name AND
      privilege IN ('SELECT', 'EXECUTE')
      AND grantable = 'YES'
  )
;

spool off
set feedback on
@doit
@grsys.tmp
set feedback off

undef obj usr

@setdefs

