rem Author:  Mark Lang, 1998
rem Name:    help.sql
rem Purpose: Display on-line help about SQL scripts
rem Usage:   @help [<srch_opt>:]<%search%> <print_opts>
rem Subject: database
rem Attrib:  sql
rem Descr:
rem Notes:   <srch_opt> and <print_opts> made up of <PSUADNL> below:
rem          P=purpose S=subject U=usage A=Attrib D=descr N=notes L=seealso
rem          <srch_opt> can only be one letter, if not specified
rem          then search by name
rem          <print_opt> can be one or all above, "Purpose:" is always
rem          displayed, "%" specifies all
rem SeeAlso:
rem History:
rem          01-feb-98  Initial release

@setup
define skey="upper(substr('&&1',1,instr('&&1',':')-1))"
define srch="upper(substr('&&1',instr('&&1',':')+1))"
define popt="upper(replace('&&2','%','PUADNL'))"

column name format a10
column text format a69 word

select
s.name
, 'Purpose: '||s.purpose
||decode(instr(&&popt, 'U'), 0, '', &&cr||'Usage:   '||s.usage)
||decode(instr(&&popt, 'S'), 0, '', &&cr||'Subject: '||s.subject)
||decode(instr(&&popt, 'A'), 0, '', &&cr||'Attrib:  '||s.attrib)
||decode(instr(&&popt, 'D'), 0, '', &&cr||'Descr:   '||s.descr)
||decode(instr(&&popt, 'N'), 0, '', &&cr||'Notes:   '||s.notes)
||decode(instr(&&popt, 'L'), 0, '', &&cr||'SeeAlso: '||s.seealso)
  text
from lang_sql_help s
where (
  (&&skey is null and upper(name) like &&srch)
  or (&&skey = 'U' and upper(usage) like &&srch)
  or (&&skey = 'S' and upper(subject) like &&srch)
  or (&&skey = 'A' and upper(attrib) like &&srch)
  or (&&skey = 'D' and upper(descr) like &&srch)
  or (&&skey = 'N' and upper(notes) like &&srch)
  or (&&skey = 'L' and upper(seealso) like &&srch)
)
order by name
;

undef skey srch popt

@setdefs
