set heading off
rem create tables
drop table lang_sql_help;
create table lang_sql_help (
  name varchar2(30)
, purpose varchar2(80)
, usage varchar2(80)
, subject varchar2(80)
, attrib varchar2(80)
, descr varchar2(2000)
, notes varchar2(2000)
, seealso varchar2(80)
);
drop public synonym lang_sql_help;
create public synonym lang_sql_help for lang_sql_help;
grant select on lang_sql_help to public;

spool helpbild.log
rem about.sql
prompt Adding help for about...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'about'
,'display database version information'
,'@about'
,'database'
,'sql'
,''
,'Same as @ver'
,''
);
rem access.sql
prompt Adding help for access...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'access'
,'show objects currently in use in the database'
,'@access <%owner.name%> <%type%> <%username%>'
,'tuning'
,'sql dba'
,''
,''
,'@locks'
);
rem access2.sql
prompt Adding help for access2...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'access2'
,'show objects currently in use in the database'
,'@access2 <%owner.name%> <%type%> <%username%>'
,'tuning'
,'sql dba'
,''
,'Groups / counts by object'
,'@access @locks'
);
rem alttab.sql
prompt Adding help for alttab...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'alttab'
,'use this as settab for creating scripts'
,'@alttab'
,'sqlplus'
,'sql'
,''
,'Put comments here'
,'@forobjs'
);
rem altusr.sql
prompt Adding help for altusr...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'altusr'
,'set user tablespace defaults'
,'@altusr <%user%> <%role%> <default_ts|*> <temp_ts|*>'
,'user'
,'sql gen ddl'
,''
,''
,''
);
rem analyze.sql
prompt Adding help for analyze...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'analyze'
,'perform variable analyze table operations'
,'@analyze <%owner.table%> <%type%> <operation>'
,'object'
,'sql gen ddl'
,''
,'d=delete statistics'
||' '||'e[til]=estiate statistics'
||' '||'[t|i|l=for table|for all indexes|for all indexed columns]'
||' '||'c[til]=compute statistics'
||' '||'vs=validate structure'
||' '||'vc=validate structure cascade'
||' '||'lc=list chained rows'
||' '||'For example:'
||' '||'e=estimate'
||' '||'et=estimate for table'
,'@estimate'
);
rem appdev.sql
prompt Adding help for appdev...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'appdev'
,'create application developer account'
,'@appdev <username>'
,'user'
,'sql ddl dba'
,''
,''
,'@appown @approl @appusr'
);
rem appown.sql
prompt Adding help for appown...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'appown'
,'create a new application schema owner account'
,'@appown <username> <data_ts> <index_ts>'
,'user'
,'sql ddl dba'
,''
,''
,'@appdev @approl @appusr'
);
rem approl.sql
prompt Adding help for approl...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'approl'
,'create application user/developer/owner roles'
,'@approl'
,'security'
,'sql dba'
,''
,''
,'@appdev @appown @appusr'
);
rem appusr.sql
prompt Adding help for appusr...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'appusr'
,'create a new user account'
,'@appusr <username> <role>'
,'user'
,'sql ddl'
,''
,''
,'@appdev @appown @approl'
);
rem args.sql
prompt Adding help for args...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'args'
,'display package function arguments'
,'@args <%owner.package%> <%object%> <%datatype%>'
,'plsql'
,'sql'
,''
,''
,'@objs'
);
rem ascii.sql
prompt Adding help for ascii...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'ascii'
,'print ascii table'
,'@ascii'
,'object'
,'pls'
,''
,'Output determined by character encoding of your terminal'
,''
);
rem aud.sql
prompt Adding help for aud...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'aud'
,'display audit session history'
,'@aud <since> <%user%> <%|u|l|d|a>'
,'security'
,'sql dml dba'
,''
,''
,''
);
rem become.sql
prompt Adding help for become...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'become'
,'become another user (local database only)'
,'@become <user>'
,'sql gen ddl dba'
,''
,''
,'Only use against LOCAL database; determined by'
||' '||'ORACLE_SID / TWO_TASK on UNIX, or LOCAL on Windows'
||' '||'user require ALTER USER privilege'
,''
);
rem bg.sql
prompt Adding help for bg...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'bg'
,'displays oracle background processes'
,'@bg <%0|*1|name>'
,'instance'
,'sql'
,''
,'Put comments here'
,''
);
rem bh.sql
prompt Adding help for bh...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'bh'
,'display buffer cache (x$bh) usage by object'
,'@bh <%owner.name%> <%minbuf%> <%bufname%>'
,'tuning'
,'sql sys v80'
,''
,''
,'@hits'
);
rem bufpool.sql
prompt Adding help for bufpool...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'bufpool'
,'display stats for mutliple buffer pools'
,'@bufpool'
,'instance'
,'sql dba v80'
,''
,''
,'@sga'
);
rem cache.sql
prompt Adding help for cache...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'cache'
,'describe contents of objects in library cache'
,'@cache <%owner.name%> <%type%> <min_size>'
,'tuning'
,''
,''
,''
,''
);
rem cantext.sql
prompt Adding help for cantext...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'cantext'
,'list segments which cant extend because of space or extents'
,'@cantext <%owner.segment_name%> <%type%> <%tablespace%> <within>'
,'space'
,''
,''
,'if within<100 then within=#extents else within=space #kb'
,'@segs @segs2 @segs3'
);
rem cinfo.sql
prompt Adding help for cinfo...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'cinfo'
,'display username and database'
,'@cinfo <%user%>'
,'session'
,'sql'
,''
,''
,'@who'
);
rem clrpwd.sql
prompt Adding help for clrpwd...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'clrpwd'
,'resets user password to a default'
,'@clrpwd <user>'
,'user'
,'sql gen ddl dba'
,''
,'Old password (encrypted) spooled to file <user>.lis'
,'@passwd'
);
rem cls.sql
prompt Adding help for cls...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'cls'
,'clear the screen'
,'@cls'
,'sqlplus'
,'sql'
,''
,''
,''
);
rem clus.sql
prompt Adding help for clus...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'clus'
,'list clusters'
,'@clus <%owner.table%> <%tablespace%>'
,'object:cluster'
,'sql'
,''
,''
,'@clustat'
);
rem clustat.sql
prompt Adding help for clustat...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'clustat'
,'list cluster statistics'
,'@clustat <%owner.cluster%> <%tablespace%>'
,'object:cluster'
,'sql'
,''
,'Theses columns in SYS.DBA_TABLES are calculated by ANALYZE'
,'@clus'
);
rem cmts.sql
prompt Adding help for cmts...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'cmts'
,'display comments on a table'
,'@cmts <%owner.table%> <%search%>'
,'object:comment'
,'sql'
,''
,''
,''
);
rem coalesce.sql
prompt Adding help for coalesce...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'coalesce'
,'perform alter tablespace ... coalesce on selected tablespaces'
,'@coalesce <%ts%>'
,'space'
,'sql gen ddl dba'
,''
,''
,'@frag'
);
rem code.sql
prompt Adding help for code...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'code'
,'display stored object information'
,'@code <%owner.name%> <%type%>'
,'plsql'
,'sql dba'
,''
,''
,'@list'
);
rem colcmp.sql
prompt Adding help for colcmp...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'colcmp'
,'compares columns in two tables'
,'@colcmp <owner.table1> <owner.table2>'
,'object:table:column'
,'sql'
,''
,''
,'@cols @miscols'
);
rem coldefs.sql
prompt Adding help for coldefs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'coldefs'
,'list column default values'
,'@coldefs <%owner.table%> <%column_name%> <%type%>'
,'object:table:column'
,'sql'
,''
,''
,'@cols'
);
rem coldict.sql
prompt Adding help for coldict...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'coldict'
,'determine use of common column names/types across tables'
,'@coldict <%owner.table%> <%colname%> <%coltype%>'
,'object:table:column'
,'sql'
,''
,''
,'@cols'
);
rem coldist.sql
prompt Adding help for coldist...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'coldist'
,'calculate distribution statistics about a column'
,'@coldist <owner.table> <colexpr>'
,'tuning'
,'sql n80'
,''
,''
,''
);
rem cols.sql
prompt Adding help for cols...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'cols'
,'list columns'
,'@cols <%owner.table%> <%column_name%> <%type%>'
,'object:table:column'
,'sql'
,''
,''
,'@coldefs @colstat'
);
rem cols2.sql
prompt Adding help for cols2...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'cols2'
,'list column summary'
,'@cols2 <%owner.table%> <%column_name%>'
,'object:table:column'
,'sql'
,''
,''
,'@cols'
);
rem colstat.sql
prompt Adding help for colstat...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'colstat'
,'list columns'
,'@colstat <%owner.table%> <%column_name%> <%type%>'
,'object:table:column'
,'sql'
,''
,''
,'@cols'
);
rem compat.sql
prompt Adding help for compat...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'compat'
,'display backward-compatibility specific features'
,'@compat <%search%>'
,'database'
,'sql dba'
,''
,'Release 0.0.0.0.0 means feature has not been used'
,'@vers'
);
rem compile.sql
prompt Adding help for compile...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'compile'
,'recompile invalid database objects'
,'@compile <%owner.name%> <%type%>'
,'plsql'
,'sql gen ddl'
,''
,''
,'@invalid'
);
rem conn.sql
prompt Adding help for conn...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'conn'
,'connect to database and set sqlprompt accordingly'
,'@conn'
,'sqlplus'
,'sql'
,''
,''
,'@whoamip'
);
rem cons.sql
prompt Adding help for cons...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'cons'
,'list constraints'
,'@cons <%owner.table%> <%constraint%> <%type%>'
,'object:table:constraint'
,'sql'
,''
,''
,'@cons2 @refs'
);
rem cons2.sql
prompt Adding help for cons2...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'cons2'
,'list summary of constraints by type'
,'@cons2 <%owner.table%> <%constraint%>'
,'object:table:constraint'
,'sql'
,''
,''
,'@cons'
);
rem count.sql
prompt Adding help for count...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'count'
,'count records'
,'@count <owner.table>'
,'data'
,'sql'
,''
,''
,'@max @mcount @min'
);
rem crrbs.sql
prompt Adding help for crrbs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'crrbs'
,'create initial public rollback segments'
,'@crrbs <num> <ext_size_k> <ext_min/opt> <ts>'
,'database'
,'sql gen ddl dba'
,''
,'Example: Create 4 public rollbacks with 10 100k extents'
||' '||'@crrbs 4 100 10 rbs'
,'01-feb-98  initial release'
);
rem crseq.sql
prompt Adding help for crseq...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'crseq'
,'create a sequence based on max value of a column'
,'@crseq [owner.]sequence table[@db] value'
,'object:sequence'
,'gen ddl own'
,''
,'if using a column use COLUMN+1'
||' '||'if you know the next value then make table DUAL'
,''
);
rem crseqs.sql
prompt Adding help for crseqs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'crseqs'
,'rebuild sequences which follow specific naming standards'
,'@crseqs <%owner.sequence%>'
,''
,'sql'
,''
,'Following naming standards must be observed to use this'
||' '||'script:'
||' '||'table PK = <table_short_name>_PK'
||' '||'sequence = <table_short_name>_<seq_column>_SEQ'
,'@crseq @seqs'
);
rem crud.sql
prompt Adding help for crud...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'crud'
,'display access to tables in crud chart by role'
,'@crud <%owner.object%> <%role%> <%type%>'
,'security'
,'sql'
,''
,'Does not include inherited grants'
,'@crud2 @privs'
);
rem crud2.sql
prompt Adding help for crud2...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'crud2'
,'display access to tables in crud chart by role'
,'@crud2 <%owner.object%> <%role%>'
,'security'
,'sql'
,''
,'Does not include inherited grants; like crud but does not group'
||' '||'by role'
,'@crud'
);
rem ctas.sql
prompt Adding help for ctas...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'ctas'
,'create table from select'
,'@ctas <name> <source_table> "<storage>"'
,'data'
,'sql'
,''
,''
,''
);
rem cursors.sql
prompt Adding help for cursors...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'cursors'
,'display open cursors'
,'@cursors <%user%>'
,'tuning'
,'sql dba'
,''
,''
,''
);
rem daily.sql
prompt Adding help for daily...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'daily'
,'execute a job daily at some specific time'
,'@daily <time> "<job>"'
,'job'
,'sql'
,''
,''
,'@jc @jobs @submit'
);
rem date.sql
prompt Adding help for date...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'date'
,'used to display datestamp'
,'@date'
,'misc'
,'sql'
,''
,''
,''
);
rem db.sql
prompt Adding help for db...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'db'
,'identify current database'
,'@db'
,'database'
,'sql'
,''
,''
,''
);
rem dbabort.sql
prompt Adding help for dbabort...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dbabort'
,'aborts an oracle instance'
,'@dbabort'
,'svrmgr'
,'mgr'
,''
,''
,'@dbshutf'
);
rem dbbegin.sql
prompt Adding help for dbbegin...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dbbegin'
,'sql*dba script to prepare database for online backup'
,'@dbbegin'
,'svrmgr'
,'mgr'
,''
,'Use from SQL*DBA or SVRMGR only'
,'@dbend'
);
rem dbend.sql
prompt Adding help for dbend...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dbend'
,'sql*dba script to take database out of online backup mode'
,'@dbend'
,'svrmgr'
,'mgr'
,''
,'Run from SQL*DBA or SVRMGR only'
,'@dbbegin'
);
rem dbpin.sql
prompt Adding help for dbpin...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dbpin'
,'sql*dba pins packages'
,'@dbping'
,'svrmgr'
,'mgr'
,''
,''
,'@dbstart'
);
rem dbshut.sql
prompt Adding help for dbshut...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dbshut'
,'bring instance down (nice)'
,'@dbshut'
,'svrmgr'
,'mgr'
,''
,''
,''
);
rem dbshutf.sql
prompt Adding help for dbshutf...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dbshutf'
,'bring instance down (hard)'
,'@dbshutf'
,'svrmgr'
,'mgr'
,''
,''
,'@dbshut'
);
rem dbsize.sql
prompt Adding help for dbsize...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dbsize'
,'display database size indicators'
,'@dbsize'
,'database'
,'sql dba n80'
,''
,''
,'@frag @ratio'
);
rem dbstart.sql
prompt Adding help for dbstart...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dbstart'
,'sql*dba script to startup an instance'
,'@dbstart'
,'svrmgr'
,'mgr'
,''
,''
,'@dbshut'
);
rem dbstartf.sql
prompt Adding help for dbstartf...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dbstartf'
,'execute startup force on instance'
,'sqldba @dbstartf'
,'svrmgr'
,'mgr'
,''
,'Run frm SQL*DBA or SVRMGR'
,''
);
rem dealloc.sql
prompt Adding help for dealloc...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dealloc'
,'deallocate unused space from table segments'
,'@dealloc <%owner.table%> <%type%> <%tablespace%> <min_kb>'
,'space'
,'sql'
,''
,'Only dealloc segments of <min_kb> size or larger'
||' '||'Use with caution'
||' '||'enh: Add functionality to specify KEEP parameter?'
,'@cantext @segs @space'
);
rem del.sql
prompt Adding help for del...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'del'
,'delete rows'
,'@del <%owner.table%>'
,'object:table'
,''
,''
,'Use with caution'
,'@trunc'
);
rem deps.sql
prompt Adding help for deps...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'deps'
,'show dependencies'
,'@deps <%owner.table%> <%ref_owner.ref_table%>'
,'object:dependency'
,'sql'
,''
,''
,'@deptree'
);
rem desc.sql
prompt Adding help for desc...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'desc'
,'enhanced sql*plus-like describe for tables'
,'@desc <%owner.table%> <keys>'
,'object:table'
,'pls v73'
,'Like sql*plus describe but includes key/index information'
||' '||'P1(2)'
||' '||'|| + column position in key'
||' '||'|+ nth key of same type (for reference)'
||' '||'+ type of key P=primary U=unique F=foreign B=bitmap I=index'
,'keys=<PURIB|%|->'
||' '||'Supports only tables and views; can specify wildcards'
||' '||'You cannot distiguish unique indexes from unique constraints'
||' '||'enh: Should add refs from other tables?'
||' '||'enh: Support procs / pkgs too'
,'@coldefs @colstat'
);
rem disablec.sql
prompt Adding help for disablec...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'disablec'
,'disables integrity constraints'
,'@disablec <%owner.table%> <type|%>[*]'
,'object:table:constraint'
,'sql gen ddl'
,''
,'Append asterisk to cascade'
,'@cons @disablek @enablec'
);
rem disabled.sql
prompt Adding help for disabled...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'disabled'
,'display disabled constraints and triggers'
,'@disabled <%owner.table%>'
,'object'
,'sql'
,''
,''
,'@cons2 @invalid @trigs2'
);
rem disablek.sql
prompt Adding help for disablek...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'disablek'
,'disables integrity constraints'
,'@disablek <%owner.table%> <type|%> <%column%>'
,'object:table:constraint'
,'sql gen ddl'
,''
,''
,'@disablec'
);
rem disablet.sql
prompt Adding help for disablet...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'disablet'
,'disable triggers'
,'@disablet <%owner.table%>'
,'object'
,'sql gen ddl'
,''
,''
,'@enablet @trigs'
);
rem doit.sql
prompt Adding help for doit...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'doit'
,'embedded script to prompt user before an action'
,'@doit'
,'sqlplus'
,'sql nst'
,''
,'Modifies DUMMY define'
,''
);
rem drop.sql
prompt Adding help for drop...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'drop'
,'drop database objects'
,'@drop <%owner.table%> <%type%>'
,'object'
,'sql gen ddl'
,''
,'USE WITH CAUTION!'
,'@dropc @dropi @droprefs @dropsegs @dropt @dropu'
);
rem dropc.sql
prompt Adding help for dropc...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dropc'
,'drop integrity constraints'
,'@dropc <%owner.table%> <type|%>[*]'
,'object:table:constraint'
,'sql gen ddl'
,''
,'* in 2nd argument causes CASCADE'
,'@disablec @drop'
);
rem dropexcl.sql
prompt Adding help for dropexcl...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dropexcl'
,'drop database objects (with exlucde parameter)'
,'@dropexcl <%owner.table%> <%type%> <%exclude%>'
,'object'
,'sql gen ddl'
,''
,'USE WITH CAUTION'
,''
);
rem dropi.sql
prompt Adding help for dropi...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dropi'
,'drop indexes on the selected tables'
,'@dropi <%owner.table%> <%index%> <%uniq%>'
,'object:table:index'
,'sql gen ddl'
,''
,''
,'@drop @idxs @segsi'
);
rem droprefs.sql
prompt Adding help for droprefs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'droprefs'
,'drop foreign keys which references specified tables'
,'@droprefs <%r_owner.r_table%> <%owner.table%>'
,'object:table:constraint'
,'sql gen ddl'
,''
,''
,'@cons @dropc @refs @restrefs @saverefs'
);
rem droprole.sql
prompt Adding help for droprole...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'droprole'
,'drop roles'
,'@droprole <%role%>'
,'security'
,'sql'
,''
,''
,''
);
rem dropsegs.sql
prompt Adding help for dropsegs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dropsegs'
,'drop database objects associated with specified segments'
,'@dropsegs <%owner.table%> <%type%> <%tablespace%>'
,'object'
,'sql gen ddl'
,''
,''
,'@drop @segs'
);
rem dropt.sql
prompt Adding help for dropt...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dropt'
,'drop triggers on a table'
,'<%owner.table%>'
,'object:table:trigger'
,'sql'
,''
,''
,'@disablet @drop @trigs'
);
rem dropu.sql
prompt Adding help for dropu...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dropu'
,'drop users'
,'@dropu <%user%> <%has_role%>'
,'user'
,'sql'
,''
,'Ignores SYS and SYSTEM'
,''
);
rem dump.sql
prompt Adding help for dump...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dump'
,'dump stored object definitions to a file'
,'@dump <%owner.object%> <filename>'
,'plsql'
,'sql'
,''
,''
,''
);
rem dumpp.sql
prompt Adding help for dumpp...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dumpp'
,'dump public synonyms'
,'@dumpp'
,'database'
,'sql'
,''
,'Useful during database recreation from exports'
,''
);
rem dumpr.sql
prompt Adding help for dumpr...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dumpr'
,'dump role definitions'
,'@dumpr'
,'security'
,'sql'
,''
,'Useful during database recreation from exports'
,''
);
rem dumpts.sql
prompt Adding help for dumpts...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dumpts'
,'create script which recreates tablespaces'
,'@dumpts <%tablespace%> <search> <replace>'
,'space'
,'sql dba'
,''
,''
,''
);
rem dumpu.sql
prompt Adding help for dumpu...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dumpu'
,'dump user definitions'
,'@dumpu <%username%>'
,'user'
,'sql'
,''
,'Useful recreating databases from exports'
,''
);
rem dups.sql
prompt Adding help for dups...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dups'
,'display rows with duplicate values'
,'@dups <owner.table> <expr>'
,'data'
,'sql'
,''
,''
,''
);
rem dupscnt.sql
prompt Adding help for dupscnt...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dupscnt'
,'display count of rows with duplicate values'
,'@dupscnt <owner.table> <expr>'
,'data'
,'sql'
,''
,''
,'@dups'
);
rem dview.sql
prompt Adding help for dview...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'dview'
,'dump view definition(s) to a flat file'
,'@dview <%owner.view%> <filename>'
,'object:view'
,'sql'
,''
,''
,''
);
rem enablec.sql
prompt Adding help for enablec...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'enablec'
,'enables integrity constraints'
,'@enablec <%owner.table%> <type|%> <exception_table|*>'
,'object:table:constraint'
,'sql gen ddl'
,''
,''
,'@disablec'
);
rem enablet.sql
prompt Adding help for enablet...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'enablet'
,'disable triggers'
,'@enablet <%owner.table%>'
,'object:table:trigger'
,'sql gen ddl'
,''
,''
,'@disablet'
);
rem enforce.sql
prompt Adding help for enforce...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'enforce'
,'enable novalidate integrity constraints, then enable'
,'@enforce <%owner.table%> <type|%> <*|exc_table>'
,'object:table:constraint'
,'sql gen ddl'
,''
,''
,'@enablec'
);
rem errors.sql
prompt Adding help for errors...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'errors'
,'show errors on a stored object'
,'@errors %[owner.]object%'
,'plsql'
,'sql'
,''
,''
,'@list'
);
rem estimate.sql
prompt Adding help for estimate...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'estimate'
,'perform analyze table on multiple tables'
,'@estimate <%owner.table%> <*|percent|rows>'
,'object:table'
,'sql gen ddl'
,''
,'if arg2<100 then asumme PERCENT else assume ROWS'
,'@analyze'
);
rem estown.sql
prompt Adding help for estown...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'estown'
,'estimate objects in a schema'
,'@estown <owner> <sample|%>'
,'object:table'
,'sql ddl'
,''
,'If sample is 0 or % then use default sample size'
||' '||'otherwise'
,'@estimate'
);
rem events.sql
prompt Adding help for events...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'events'
,'display system events from v$system_event'
,'@events <%user%|avg|0> <%search%> <min_wait>'
,'tuning'
,'sql dab'
,''
,''
,'@waits'
);
rem except.sql
prompt Adding help for except...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'except'
,'display formatted exceptions table'
,'@except <%owner.table%>'
,'object:table:constraint'
,'sql'
,''
,''
,'@exceptd @exceptl'
);
rem expl.sql
prompt Adding help for expl...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'expl'
,'does structured display of explain plan'
,'@expl <explain_id>'
,'tuning'
,'sql'
,''
,'Like explain.sql but shows plan_text only with full 80 char'
,'@explain'
);
rem explain.sql
prompt Adding help for explain...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'explain'
,'does structured display of explain plan'
,'@explain <explain_id> <long>'
,'tuning'
,'sql'
,''
,'Must run AFTER doing the EXPLAIN PLAN command'
,'@expl @explcnt @explsel @explstat'
);
rem explcnt.sql
prompt Adding help for explcnt...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'explcnt'
,'do explain plan on "select count(*) from <table>"'
,'@explcnt <table>'
,'tuning'
,'sql'
,''
,''
,'@explstmt'
);
rem explsel.sql
prompt Adding help for explsel...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'explsel'
,'do explain plan on "select count(*) from <table>"'
,'@explsel <table>'
,'tuning'
,'sql'
,''
,''
,'@explstmt'
);
rem explstat.sql
prompt Adding help for explstat...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'explstat'
,'does structured display of explain plan'
,'@explstat <explain_id>'
,'tuning'
,'sql'
,''
,'Must run AFTER doing the EXPLAIN PLAN command'
,'@explain'
);
rem explstmt.sql
prompt Adding help for explstmt...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'explstmt'
,'do explain plan on given statement'
,'@explsel "stmt"'
,'tuning'
,'sql'
,''
,''
,'@explain @expltab'
);
rem expltab.sql
prompt Adding help for expltab...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'expltab'
,'create plan_table for explain plan'
,'@expltab'
,'tuning'
,'sql ddl'
,''
,'Based on 7.3 PLAN_TABLE'
,'@explain @explstmt'
);
rem exts.sql
prompt Adding help for exts...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'exts'
,'list segment extents'
,'@exts <%owner.segment%> <tablespace> <min_extent>'
,'space'
,'sql dba'
,''
,''
,'@segs'
);
rem files.sql
prompt Adding help for files...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'files'
,'display datafiles'
,'@files <%file_name%> <%tablespace%> <%status%>'
,'database'
,'sql dba'
,''
,''
,'@frag @ts'
);
rem filext.sql
prompt Adding help for filext...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'filext'
,'show datafile autoextend characteristics'
,'@filext <%file_name%>'
,'database'
,'sql dba v72'
,''
,''
,'@files @frag'
);
rem finger.sql
prompt Adding help for finger...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'finger'
,'display username and database'
,'@finger <db> <%user%>'
,'session'
,'sql'
,''
,''
,'@who'
);
rem forcols.sql
prompt Adding help for forcols...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'forcols'
,'performs "command" on each column'
,'@forcols <%owner.table%> <%column%> <%datatype%>'
,'misc'
,'sql gen'
,''
,'Use with caution'
||' '||'Executes <command> for each object matched--substitutions to'
||' '||'<command> are made as follows:'
||' '||'{o}	owner'
||' '||'{n}	object_name'
||' '||'{c}     column_name'
||' '||'{y}	data_type'
,'@forobj'
);
rem forobjs.sql
prompt Adding help for forobjs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'forobjs'
,'performs "command" on each object'
,'@forobjs <%owner.table%> <%type%> <%tspace%> <%role%> "<command>"'
,'misc'
,'sql gen'
,''
,'Use with caution'
||' '||'Executes <command> for each object matched--substitutions to'
||' '||'<command> are made as follows:'
||' '||'{o}	owner'
||' '||'{n}	object_name'
||' '||'{y}	object_type'
,'@all @apply'
);
rem frag.sql
prompt Adding help for frag...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'frag'
,'displays database fragmentation'
,'@frag <%ts%> <max_free|%>'
,'space'
,'sql dba'
,''
,''
,'@segs @space'
);
rem grobj.sql
prompt Adding help for grobj...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'grobj'
,'grant names on an object'
,'@grobj <priv[*]> <%owner.object%> <%type%> <user|role>'
,'security'
,'sql'
,''
,''
,'@crud @privs'
);
rem grsys.sql
prompt Adding help for grsys...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'grsys'
,'grants select on sys tables'
,'@grsys <%object%> <user>'
,'security'
,'sql gen ddl sys'
,'Grante SELECT WITH GRANT OPTION to users'
,'USE WITH CAUTION'
,'@grobj'
);
rem help.sql
prompt Adding help for help...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'help'
,'display on-line help about sql scripts'
,'@help [<srch_opt>:]<%search%> <print_opts>'
,'database'
,'sql'
,''
,'<srch_opt> and <print_opts> made up of <PSUADNL> below:'
||' '||'P=purpose S=subject U=usage A=Attrib D=descr N=notes L=seealso'
||' '||'<srch_opt> can only be one letter, if not specified'
||' '||'then search by name'
||' '||'<print_opt> can be one or all above, "Purpose:" is always'
||' '||'displayed, "%" specifies all'
,''
);
rem helpbild.sql
rem helpdrop.sql
prompt Adding help for helpdrop...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'helpdrop'
,'drops sql library help tables'
,'@helpdrop'
,'sqlplus'
,'sql'
,''
,''
,'@installg @uninstg'
);
rem hier.sql
prompt Adding help for hier...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'hier'
,'display role hierarchy for a parent role'
,'@hier <role> <levels|%>'
,'security'
,'pls dba n80'
,''
,'if levels>0 then show to N level'
||' '||'if levels=0 then show unlimited depth'
||' '||'if levels<0 then show parents'
||' '||'% defaults to "0"'
||' '||'enh: Cant use in v8 because TYPE is TYPE# in SYS.USER$'
,'@privs'
);
rem hits.sql
prompt Adding help for hits...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'hits'
,'display primary oracle internal hit ratios and memory'
,'@hits <db>'
,'tuning'
,'sql dba'
,''
,'LC=library cache'
||' '||'DC=dictionary cache'
||' '||'BC=buffer cache'
||' '||'SORTS=sorts to disk'
||' '||'(include recomended values)'
,'@ratio'
);
rem idxs.sql
prompt Adding help for idxs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'idxs'
,'list indexes'
,'@idxs <%owner.table%> <%index%>'
,'object:table:index'
,'sql'
,''
,''
,'@idxstat @segsi'
);
rem idxstat.sql
prompt Adding help for idxstat...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'idxstat'
,'list index statistics'
,'@idxstat <%owner.table%> <%index%>'
,'object:table:index'
,'sql'
,''
,''
,'@idxs'
);
rem initora.sql
prompt Adding help for initora...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'initora'
,'create database init.ora'
,'@initora <opts>'
,'instance'
,'sql out dba'
,''
,''
,''
);
rem ins.sql
prompt Adding help for ins...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'ins'
,'insert rows from one table into another'
,'@ins <dest> <source>'
,'data'
,'sql'
,''
,''
,'@del'
);
rem install.sql
prompt Adding help for install...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'install'
,'installed sql library globally'
,'@install'
,'sqlplus'
,'sql'
,''
,'Recommend to use SYSTEM account (not SYS)'
,'@uninst'
);
rem invalid.sql
prompt Adding help for invalid...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'invalid'
,'display database objects of some type'
,'@invalid <%owner.name%> <%type%>'
,'plsql'
,'sql'
,''
,''
,'@compile'
);
rem io.sql
prompt Adding help for io...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'io'
,'display oracle i/o distribution by file, tablespace, or device'
,'@io <f|t|d>'
,'tuning'
,'sql'
,''
,'f=by file, t=by tspace, d=by device/mount point'
,''
);
rem jc.sql
prompt Adding help for jc...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'jc'
,'job control'
,'@jc <job#> <flags[*]> <arg|%>'
,'job'
,'pls dml'
,''
,'flags:'
||' '||'b=break    d=remove     x=run'
||' '||'w=what     n=next_date  i=interval'
||' '||'p=check_privs'
||' '||'*=Performs a COMMIT'
,'@jobs @submit'
);
rem jobs.sql
prompt Adding help for jobs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'jobs'
,'displays information about a job'
,'@jobs <%what%>'
,'job'
,'sql'
,''
,''
,'@jc @submit'
);
rem keeps.sql
prompt Adding help for keeps...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'keeps'
,'displays size of objects pinned in sga'
,'@keeps <%owner.name%> <minkb>'
,'instance'
,'sql dba v80'
,''
,'DBA_KEEPSIZES package must be accessible'
,'@sgastat @pin @unpin'
);
rem keys.sql
prompt Adding help for keys...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'keys'
,'display primary, unique, foreign keys on table or column'
,'@keys <%owner.table%> <%type%> <%column%>'
,'object'
,'sql'
,''
,''
,'@cons @refs'
);
rem kill.sql
prompt Adding help for kill...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'kill'
,'kills active users session'
,'@kill <%username%> <sid,serial#>'
,'session'
,'sql'
,''
,''
,'@sess @who'
);
rem langutil.sql
rem lastsql.sql
prompt Adding help for lastsql...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'lastsql'
,'display last executed sql statement by session with stats'
,'@lastsql <%user%> <%status%>'
,'session'
,'sql dba'
,''
,''
,'@sqlarea'
);
rem lic.sql
prompt Adding help for lic...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'lic'
,'show licensing information'
,'@lic'
,'instance'
,'sql'
,''
,''
,'@vers'
);
rem like.sql
prompt Adding help for like...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'like'
,'create an oracle user account like another account'
,'@like <new_user> <like_user>'
,'user'
,'sql'
,''
,'enh: rename script?'
,'@users'
);
rem links.sql
prompt Adding help for links...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'links'
,'list database links'
,'@links <%owner.link%>'
,'object:dblink'
,'sql'
,''
,''
,''
);
rem list.sql
prompt Adding help for list...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'list'
,'list source code'
,'@list <owner.name> <type> <line_start> <line_end>'
,'plsql'
,'sql'
,''
,''
,'@code @errors @invalid'
);
rem lockdef.sql
prompt Adding help for lockdef...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'lockdef'
,'displays lock compatibility table'
,'@locks'
,'tuning'
,'sql'
,''
,'Includes detailed description of lock types'
,''
);
rem locks.sql
prompt Adding help for locks...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'locks'
,'displays active locks'
,'@locks'
,'tuning'
,'sql dba'
,''
,'Includes detailed description of lock type'
,''
);
rem logf.sql
prompt Adding help for logf...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'logf'
,'display redo logs information'
,'@logf '
,'database'
,'sql dba'
,''
,''
,''
);
rem logs.sql
prompt Adding help for logs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'logs'
,'display redo logs information'
,'@logs '
,'database'
,'sql dba'
,''
,''
,''
);
rem longops.sql
prompt Adding help for longops...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'longops'
,'display long running operations in v$session_longops'
,'@longops'
,'session'
,'sql dba v80'
,''
,''
,'@sess @stats'
);
rem lowcard.sql
prompt Adding help for lowcard...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'lowcard'
,'list indexes on low cardinality columns'
,'@lowcard <%owner.table%> <max_percent_distinct>'
,'object:table:index'
,'sql'
,''
,'Requires ANALYZE..STATISTICS on tables and indexes'
||' '||'<pct>=distinct_keys/num_rows*100'
,'@idxstat'
);
rem lrustat.sql
prompt Adding help for lrustat...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'lrustat'
,'display buffer cache statistics in x$kcbrbh and x$kcbcbh'
,'@lrustat <interval>'
,'tuning'
,'sql sys'
,''
,'This script can only be run as SYS.'
||' '||'Otherwise, you will get a "table or view does not exist" error.'
,'@hits @ratio'
);
rem ls.sql
prompt Adding help for ls...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'ls'
,'unix-style list of objects'
,'@ls <%owner.name%>'
,'object'
,'sql'
,''
,'Can use UNIX-style wildcards (* and ?)'
||' '||'enh: show privs rw-rw-rw-?'
,''
);
rem max.sql
prompt Adding help for max...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'max'
,'get max value for a column'
,'@max <owner.table> <expr>'
,'data'
,'sql'
,''
,''
,'@count @min'
);
rem mcount.sql
prompt Adding help for mcount...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'mcount'
,'count records in multiple tables'
,'@mcount <%owner.table%> <%type%>'
,'data'
,'sql gen'
,''
,''
,'@count'
);
rem min.sql
prompt Adding help for min...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'min'
,'get min for a column'
,'@min <owner.table> <expr>'
,'data'
,'sql'
,''
,''
,'@count @max'
);
rem miscols.sql
prompt Adding help for miscols...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'miscols'
,'report missing columns in current database from another'
,'@miscols <%owner.name%> <%column_name%> <%data_type%> <db>'
,'object:table:column'
,'sql'
,''
,'Use in the database which is missing columns'
,'@miscons @misobjs'
);
rem miscons.sql
prompt Adding help for miscons...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'miscons'
,'report missing constraints in current database from another'
,'@miscons <%owner.name%> <%constraint_type%> <db>'
,'object:table:constraint'
,'sql'
,''
,'Use in the database which is missing constraints'
,'@miscols @misobjs'
);
rem misobjs.sql
prompt Adding help for misobjs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'misobjs'
,'report missing objects in current database from another'
,'@misobjs <%owner.name%> <%object_type%> <db>'
,'object'
,'sql'
,''
,'Use in the database which is missing objects'
,'@miscols @miscons'
);
rem MKEXP.SQL
prompt Adding help for mkexp...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'mkexp'
,'create a table export .par file'
,'@mkexp <%owner.name%> <%tablespace%> <parfile>'
,'database'
,'sql gen'
,''
,'.PAR extension is NOT appened to <parfile>'
||' '||'If owner is wildcarded then each table listed in'
||' '||'<parfile> will be prefixed with "owner."'
||' '||'File may require editing after generation, use this'
||' '||'script to create prototype only'
,''
);
rem movefile.sql
prompt Adding help for movefile...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'movefile'
,'generates script to move datafiles to another disk'
,'@movefile <%filename%> <search> <replace>'
,'database'
,'sql'
,''
,''
,''
);
rem mts.sql
prompt Adding help for mts...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'mts'
,'display mts parameters'
,'@mts'
,'mts'
,'sql'
,''
,'use mtsmon instead'
,'@mtsmon'
);
rem mtsmon.sql
prompt Adding help for mtsmon...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'mtsmon'
,'monitor multi-threaded server activity'
,'@mtsmon <%|c|d|m|q|s>'
,'mts'
,'sql dba'
,''
,''
,''
);
rem nls.sql
prompt Adding help for nls...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'nls'
,'display nls parameters'
,'@nls'
,'nls'
,'sql'
,''
,''
,''
);
rem noaccess.sql
prompt Adding help for noaccess...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'noaccess'
,'lists items which have no grants'
,'@noaccess <%owner.name%>'
,'security'
,'sql dba'
,''
,''
,'@privs'
);
rem nofk.sql
prompt Adding help for nofk...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'nofk'
,'show tables with no foreign key relationships'
,'@nofk <%owner.table%>'
,'quality'
,'sql'
,''
,'Table has no foreign keys in or out'
,'@cons @nopk'
);
rem nopk.sql
prompt Adding help for nopk...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'nopk'
,'show tables with no primary keys'
,'@nopk <%owner.table%>'
,'quality'
,'sql'
,''
,''
,'@nofk'
);
rem notfound.sql
prompt Adding help for notfound...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'notfound'
,'show exceptions to a possible foreign key column'
,'@notfound <owner.table1> <col1> <owner.table2> <col2>'
,'data'
,'sql'
,''
,''
,''
);
rem nullcols.sql
prompt Adding help for nullcols...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'nullcols'
,'list columns in tables which are all null'
,'@nullcols <%owner.table%> <%colname> <%data_type%>'
,'data'
,'sql'
,''
,''
,''
);
rem nvl.sql
prompt Adding help for nvl...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'nvl'
,'set value in column if null'
,'@nvl <owner.table> <column> <value>'
,'data'
,'sql dml'
,''
,''
,'@nullcols'
);
rem objs.sql
prompt Adding help for objs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'objs'
,'display database objects of some type'
,'@objs <%owner.name%> <%type%>'
,'object'
,'sql'
,''
,''
,'@objs2'
);
rem objs2.sql
prompt Adding help for objs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'objs'
,'display summary of database objects by type'
,'@objs2 <%owner.name%> <%type%>'
,'object'
,'sql'
,''
,''
,'@objs'
);
rem output.sql
prompt Adding help for output...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'output'
,'set serveroutput and feeadback features on'
,'@output'
,'sqlplus'
,'sql'
,''
,''
,''
);
rem paramd.sql
prompt Adding help for paramd...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'paramd'
,'display instance parameters (from init.ora)'
,''
,'instance'
,'sql dba'
,''
,''
,'@params'
);
rem params.sql
prompt Adding help for params...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'params'
,'display instance parameters (from init.ora)'
,'@params <%parameter%> <%|true|false>'
,'instance'
,'sql dba'
,''
,''
,'@paramd'
);
rem parts.sql
prompt Adding help for parts...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'parts'
,'list table partitions'
,'@parts <%owner.table%> <%ts%>'
,'object:table:partition'
,'sql v80'
,''
,''
||' '||'SeeOnly: partstat.sql'
,''
);
rem partstat.sql
prompt Adding help for partstat...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'partstat'
,'list table statistics'
,'@partstat <%owner.table%> <%ts%>'
,'object:table:partition'
,'sql v80'
,''
,'Theses columns in SYS.DBA_TABLES are calculated by ANALYZE'
||' '||'NUM_ROWS	number of rows '
||' '||'BLOCKS		blocks below high-water mark'
||' '||'EMPTY_BLOCKS	blocks above high-water mark'
||' '||'AVG_SPACE	average free space in blocks below high-water'
||' '||'CHAIN_CNT	number of chained or migrated rows'
,'parts.sql'
);
rem partvals.sql
prompt Adding help for parts...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'parts'
,'list table partitions'
,'@parts <%owner.table%> <%ts%>'
,'object:table:partition'
,'sql v80'
,''
,''
||' '||'SeeOnly: @partstat'
,''
);
rem passwd.sql
prompt Adding help for passwd...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'passwd'
,'change user password'
,'@passwd'
,'user'
,'pls ddl'
,''
,''
,''
);
rem pga.sql
prompt Adding help for pga...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'pga'
,'display user pga memory usage'
,'@pga <%user%> <%|minpga>'
,'tuning:memory'
,'sql dba'
,''
,''
,'@stats @uga'
);
rem pin.sql
prompt Adding help for pin...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'pin'
,'pin packages in sga'
,'@pin <%owner.object%>'
,'instance'
,'sql gen dba'
,''
,''
,''
);
rem ping.sql
prompt Adding help for ping...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'ping'
,'ping a database'
,'@ping <db>'
,'instance'
,'sql'
,''
,''
,''
);
rem plans.sql
prompt Adding help for plans...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'plans'
,'quickly shows plans in plan_table'
,'@plans'
,'tuning'
,'sql'
,''
,''
,'@explain'
);
rem pq.sql
prompt Adding help for pq...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'pq'
,'show parallel query vital stats'
,'@pq'
,'tuning'
,'sql dba'
,''
,''
,''
);
rem privs.sql
prompt Adding help for privs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'privs'
,'display privilegs granted to a users or role'
,'@privs <%grantee%> <%type%> <%privilege%> <%owner.table%>'
,'security'
,'sql dba'
,''
,'<type>=<SRTC|%> S=system R=role T=table C=column'
||' '||'Unless you are DBA all privs may not be displayed'
,''
);
rem profs.sql
prompt Adding help for profs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'profs'
,'display profiles'
,'@profs <%profile%> <%resouce%> <%limit%>'
,'user'
,'sql'
,''
,''
,''
);
rem protect.sql
prompt Adding help for protect...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'protect'
,'mass change password for group of users'
,'@protect <%user%> <%has_role%> <ur|%> <has_password?>'
,'user'
,''
,''
,''
,''
);
rem pubs.sql
prompt Adding help for pubs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'pubs'
,'display public synonyms'
,'@pubs <%name%> <%referenced_object%>'
,'object:synonym'
,'sql'
,''
,'enh: show if object exists (local)?'
,''
);
rem pubsyn.sql
prompt Adding help for pubsyn...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'pubsyn'
,'resolve public synonyms for objects in a schema'
,'@pubsyn <%owner.name%>'
,'object:synonym'
,'sql dba'
,'This useful script will maintain PUBLIC SYNONYMS for objects'
||' '||'in a schema'
||' '||'If existing synonym exists which points to something '
||' '||'different the drop existing'
||' '||'If synonym does not exist then create'
||' '||'If existing synonym points to non-existant object then drop'
||' '||'Does not create public synonyms for synonyms'
,'Currently OWNER cannot be a wildcard'
,'@pubs'
);
rem purgeaud.sql
prompt Adding help for purgeaud...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'purgeaud'
,'purge audit trail'
,'@purgeaud <days>'
,'security'
,'sql dba n80'
,''
,'enh: Oracle8 doesnt recognize timestamp column'
,'@aud'
);
rem qacons.sql
prompt Adding help for qacons...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'qacons'
,'remove redundant constraints'
,'@qacons <%owner.table%> <%constraint_type%>'
,'quality'
,'sql gen ddl'
,''
,''
,'@cons'
);
rem qaidxs.sql
prompt Adding help for qaidxs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'qaidxs'
,'remove redundant indexes from tables'
,'@qaidxs <%owner.table%>'
,'quality'
,'sql gen ddl'
,'Index is redundant if another composite index exists which is'
||' '||'prefixed with the same columns'
||' '||'Notes:'
,''
,'@idxs @qacons'
);
rem qann.sql
prompt Adding help for cknn...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'cknn'
,'checks/removes redundant not nulls on primary key columns'
,'@cknn <%owner.table%>'
,'quality'
,'sql gen ddl'
,''
,'SHOULD THIS BE USED??'
,'@qacons'
);
rem quotas.sql
prompt Adding help for quotas...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'quotas'
,'use this as s quotas for creating scripts'
,'@quotas <%user%> <%ts%|0> <min_used_kb|%>'
,'user'
,'sql dba'
,''
,'<ts>=0 shows total quota used for all tablespaces'
||' '||'If <min_used_kb> > 0 then sort by used'
,''
);
rem rbs.sql
prompt Adding help for rbs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'rbs'
,'display rollback segments'
,'@rbs'
,'database'
,'sql gen ddl dba'
,''
,''
,'@rbsstat'
);
rem rbsoff.sql
prompt Adding help for rbsoff...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'rbsoff'
,'set available rollback segments online'
,'@rbsoff <%rbs%>'
,'database'
,'sql dba'
,''
,''
,'@rbson'
);
rem rbson.sql
prompt Adding help for rbson...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'rbson'
,'set available rollback segments online'
,'@rbson <%rbs%>'
,'database'
,'sql dba'
,''
,''
,'@rbsoff'
);
rem rbsstat.sql
prompt Adding help for rbsstat...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'rbsstat'
,'display rollback segments with tuning information'
,'@rbsstat <%rbsname%>'
,'database'
,'sql dba'
,''
,''
,'@rbs'
);
rem rebuild.sql
prompt Adding help for rebuild...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'rebuild'
,'move indexes to another tablespace'
,'@rebuild <%owner.table%> <%index%> <%tspace%> <new_tspace|*>'
,'object:table:index'
,'sql gen ddl'
,''
,''
,'@idxs'
);
rem refgrps.sql
prompt Adding help for refgrps...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'refgrps'
,'display refresh groups'
,'@refgrps <%owner.name%>'
,'object:snapshot'
,'sql'
,''
,''
,'@jobs @snaps'
);
rem refs.sql
prompt Adding help for refs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'refs'
,'display foreign keys which references specified tables'
,'@refs <%r_owner.r_table%> <%owner.table%>'
,'object:table:constraint'
,'sql '
,''
,''
,'@cons'
);
rem reftree.sql
prompt Adding help for reftree...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'reftree'
,'display fk references in tree format'
,'@reftree <%owner.table%> <cnt_refs> <level>'
,'object:table:constraint'
,'pls dba n80'
,''
,'if <cnt_refs> >=0 then table must have no more than N refs'
||' '||'if <cnt_refs> < 0 then table must have less than N refs'
||' '||'if <level> > 0 then display N refs'
||' '||'if <level> = 0 then display all refs'
||' '||'if <level> < 0 then display inverse to N levels'
,'@refs'
);
rem rels.sql
prompt Adding help for rels...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'rels'
,'display relationships between tables'
,'@rels <%owner.child%> <%owner.parent%>'
,'object:table:constraint'
,'pls dba'
,''
,'Relations of format'
||' '||'(opt|man) [m:1 (opt:man)'
||' '||'[mM1][:+]1'
||' '||'1:1  one to one , foreign key in primary key'
||' '||'1+1  one to one , foreign key prefix of primary key'
||' '||'M:1  one to many, foreign key in primary key'
||' '||'M+1  one to many, foreign key prefix of primary key'
||' '||'m:1  one to many  (normal)'
,'@cons @refs'
);
rem rename.sql
prompt Adding help for rename...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'rename'
,'script to mass rename objects'
,'@rename <%owner.name%> <find_string> <repl_string>'
,'object'
,'sql gen ddl'
,''
,'Currently rename tables and views only'
,''
);
rem restidxs.sql
prompt Adding help for restidxs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'restidxs'
,'restore indexes defined in save_indexes table'
,'@restidxs <%>'
,'misc'
,'sql dyn ddl'
,''
,''
,'@saveidxs'
);
rem restrefs.sql
prompt Adding help for restrefs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'restrefs'
,'restore fk references saved in saved_constraints'
,'@restrefs <%owner.table%>'
,'misc'
,'pls dyn ddl'
,''
,''
,'@saverefs'
);
rem roles.sql
prompt Adding help for roles...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'roles'
,'list roles'
,'@roles <%role%> <%granted_to%>'
,'security'
,'sql'
,''
,''
,''
);
rem rvobj.sql
prompt Adding help for rvobj...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'rvobj'
,'revoke access to objects from users or roles'
,'@rvobj <%privilege%>[*] <%owner.name%> <%user|role%>'
,'security'
,'sql gen ddl own'
,''
,'Use with caution!'
||' '||'* forces cascade constraints when REVOKE REF..'
,'@grobj @privs'
);
rem rvsys.sql
prompt Adding help for rvsys...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'rvsys'
,'revokes select on sys tables from a user'
,'@rvsys <%object%> <user>'
,'security'
,'sql'
,''
,''
,'@grsys'
);
rem saveidxs.sql
prompt Adding help for saveidxs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'saveidxs'
,'save index definitions in save_indexes table'
,'@saveidxs <table> <index> <uniqueness/type>'
,'misc'
,'sql dyn ddl'
,''
,''
,'23-mar-98  initial release'
);
rem saverefs.sql
prompt Adding help for saverefs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'saverefs'
,'save foreign keys which references specified tables'
,'@saverefs <%r_owner.r_table%> <%owner.table%>'
,'misc'
,'sql dyn ddl'
,''
,'Table name is SAVED_CONSTRAINTS'
,'@cons @droprefs @refs @restrefs'
);
rem schema.sql
prompt Adding help for schema...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'schema'
,'change user default schema for resolving object names'
,'@schema <user|*>'
,'user'
,'sql ddl'
,'*=sets back to current user'
,'User privileges are not affected by this command'
||' '||'This is not a docuemented command'
,'@whoami'
);
rem search.sql
prompt Adding help for search...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'search'
,'search source code for patterns'
,'@search <%owner.name%> <%type%> <%search%> <[+-]win>'
,'plsql'
,'sql'
,''
,'Display window around matching line is determined by <[+-]win>'
,''
);
rem segs.sql
prompt Adding help for segs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'segs'
,'list segments'
,'@segs <%owner.segment_name%> <%type%> <%tablespace%>'
,'space'
,'sql'
,''
,''
,''
);
rem segs2.sql
prompt Adding help for segs2...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'segs2'
,'list segments grouped by segment type'
,'@segs2 <%owner.segment_name%> <%type%> <%tablespace%> '
,'space'
,''
,''
,''
,'@segs'
);
rem segs3.sql
prompt Adding help for segs3...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'segs3'
,'list segments'
,'@segs3 <%owner.segment_name%> <%type%> <%tablespace%> <exts> <blocks>'
,'space'
,'sql'
,''
,'Like @segs but with with parameters to filter by size'
,'@segs'
);
rem segsi.sql
prompt Adding help for segsi...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'segsi'
,'list segments for indexes on selected tables'
,'@segsi <%owner.segment_name%> <%tablespace%>'
,'space:segment:index'
,'sql'
,''
,''
,'@segs'
);
rem sel.sql
prompt Adding help for sel...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'sel'
,'shorthand for "select * from ..."'
,'@sel'
,'data'
,'sql'
,''
,''
,''
);
rem seqs.sql
prompt Adding help for seqs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'seqs'
,'list sequences'
,'@seqs <%owner.table%>'
,'object:sequence'
,'sql'
,''
,''
,'@crseq @objs'
);
rem sess.sql
prompt Adding help for sess...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'sess'
,'show users session information'
,'@sess <%username%> <%status%>'
,'session'
,'sql dba'
,''
,''
,'@users @who'
);
rem sessio.sql
prompt Adding help for sessio...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'sessio'
,'display io and hit ratio by session'
,'@sessio <%user%> <%|s|u|a>'
,'tuning'
,'sql dba'
,''
,''
,'@hits @sess @stats'
);
rem setbuf.sql
prompt Adding help for setbuf...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'setbuf'
,'set buffer_pool for tables'
,'@setbuf <%owner.table%> <buffer_pool>'
,'object:table'
,'sql gen ddl v80'
,''
,''
,'@setbufi'
);
rem setbufi.sql
prompt Adding help for setbufi...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'setbufi'
,'set buffer_pool for tables'
,'@setbufi <%owner.table%> <%owner.index_name%> <buffer_pool>'
,'object:table'
,'sql gen ddl v80'
,''
,''
,''
);
rem setdefs.sql
prompt Adding help for setdefs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'setdefs'
,'restore default sqlplus sets'
,'@setdefs'
,'sqlplus'
,'sql nst'
,''
,''
,'@setup'
);
rem setpq.sql
prompt Adding help for setpq...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'setpq'
,'set parallel characteristics of tables'
,'@setpq <%owner.table%> <degree|d|*> <instances|d|*>'
,'object:table'
,'sql gen ddl'
,''
,'* means do not modify'
,''
);
rem setts.sql
prompt Adding help for setts...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'setts'
,'set default storage for tablespaces'
,'@setts <%tablespace%> <pctfree>'
,'database'
,'sql gen ddl dba'
,''
,''
,''
);
rem settx.sql
prompt Adding help for settx...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'settx'
,'set transaction use rollback segment xx'
,'@settx <rollback_seg>'
,'session'
,'sql ddl'
,''
,''
,''
);
rem setup.sql
prompt Adding help for setup...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'setup'
,'setup environment for all scripts'
,'@setup'
,'sqlplus'
,'sql nst'
,''
,''
,''
);
rem setup1.sql
prompt Adding help for setup1...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'setup1'
,'setup for script with 1 argument'
,'@setup1'
,'sqlplus'
,'sql nst'
,''
,'Define macros for spliting <%owner.name%> arguments'
||' '||'Owner default to USER if not specified, even with "%"'
||' '||'to wildcard all objects use "%.%"'
,''
);
rem setup2.sql
prompt Adding help for setup2...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'setup2'
,'setup for scripts with 2 arguments'
,'@setup2'
,'sqlplus'
,'sql nst'
,''
,'Define macros for spliting <%owner.name%> arguments'
||' '||'Owner default to USER if not specified, even with "%"'
||' '||'to wildcard all objects use "%.%"'
,''
);
rem setup3.sql
prompt Adding help for setup3...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'setup3'
,'setup for scripts with 3 arguments'
,'@setup3'
,'sqlplus'
,'sql nst'
,''
,'Define macros for spliting <%owner.name%> arguments'
||' '||'Owner default to USER if not specified, even with "%"'
||' '||'to wildcard all objects use "%.%"'
,''
);
rem setup4.sql
prompt Adding help for setup4...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'setup4'
,'setup for scripts with 3 arguments'
,'@setup4'
,'sqlplus'
,'sql nst'
,''
,'Define macros for spliting <%owner.name%> arguments'
||' '||'Owner default to USER if not specified, even with "%"'
||' '||'to wildcard all objects use "%.%"'
,''
);
rem setupdb.sql
prompt Adding help for setupdb...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'setupdb'
,'accept parameter as database; ?=local'
,'@@setupdb'
,'sqlplus'
,'sql nst'
,''
,'Places database in "db" define'
,''
);
rem setusr.sql
prompt Adding help for setusr...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'setusr'
,'setup environment to run scripts and dba or non-dba'
,'@setusr'
,'sqlplus'
,'sql nst'
,''
,''
,'05-feb-98  initial release'
);
rem setver.sql
prompt Adding help for setver...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'setver'
,'set defines to support version 8'
,'@setver'
,'sqlplus'
,'sql nst'
,''
,''
,'@setup'
);
rem sga.sql
prompt Adding help for sga...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'sga'
,'display sga for database'
,'@sga'
,'instance'
,'sql'
,''
,''
,'@sgastat'
);
rem sgastat.sql
prompt Adding help for sgastat...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'sgastat'
,'display memory allocation in sga'
,'@sgastat <%name%> <minb>'
,'tuning'
,'sql dba'
,''
,'If <minb> is specified then sort by bytes'
,'@sga'
);
rem sh.sql
prompt Adding help for sh...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'sh'
,'calulates size of shared pool based on # of users'
,'@sh <# of users>'
,'tuning'
,'sql'
,''
,''
,'@sga'
);
rem short.sql
prompt Adding help for short...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'short'
,'display object represented by short name'
,'@short <short_name>'
,'object'
,'sql'
,''
,'Must follow naming convention for primary key'
||' '||'<short>_PK or PK_<short>'
||' '||'Table must currently have primary key'
,'@cons'
);
rem sizes.sql
prompt Adding help for sizes...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'sizes'
,'display objects in shared pool'
,'@sizes <minkb>'
,'instance'
,'pls dba'
,''
,'DBMS_SHARED_POOL package must be accessible'
,'@sgastat @pin @unpin'
);
rem slogs.sql
prompt Adding help for slogs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'slogs'
,'display snapshot logs'
,'@slogs <%owner.name%>'
,'object:snapshot'
,'sql'
,''
,''
,'@snaps @refgrp'
);
rem snaps.sql
prompt Adding help for snaps...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'snaps'
,'display snapshots'
,'@snaps <%owner.name%>'
,'object:snapshot'
,'sql'
,''
,'Assumes ".world" domain'
,'@jobs @objs @refgrp'
);
rem space.sql
prompt Adding help for space...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'space'
,'display unused space within segment extents'
,'@space <%owner.name%> <%type%> <%tablespace%>'
,'space'
,'sql'
,''
,''
,'@frag @segs'
);
rem space8.sql
prompt Adding help for space8...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'space8'
,'display unused space within segment extents'
,'@space8 <%owner.name%> <%type%> <%tablespace%>'
,'space'
,'sql v80'
,''
,'enh: merge with @space in future release'
||' '||'fix: got error for object type in system account'
,'@space'
);
rem spacemap.sql
prompt Adding help for spacemap...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'spacemap'
,'display map of tablespace fragmentation'
,'@spacemap <tablespace> <%type%>'
,'space'
,'sql'
,''
,''
,'@frag'
);
rem sqlarea.sql
prompt Adding help for sqlarea...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'sqlarea'
,'display memory usage in sql area'
,'@sqlarea'
,'tuning'
,'sql'
,''
,'enh: needs more parameters'
,'@lastsql'
);
rem sroles.sql
prompt Adding help for sroles...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'sroles'
,'display session_roles view'
,'@sroles <%role%>'
,'user'
,'sql'
,''
,''
,'@privs @roles @whoami'
);
rem srows.sql
prompt Adding help for srows...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'srows'
,'display table row(s) in tabular format'
,'@srows <owner.table> <where_clause>'
,'database'
,'sql gen'
,''
,''
,''
);
rem stats.sql
prompt Adding help for stats...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'stats'
,'shows session/system statistics'
,'@stats <%user%|0|aggr={sum|min|max|avg|std|var|dis}> <%stat%> <minval|%>'
,'instance'
,'sql dba'
,''
,'<user>=user stats'
||' '||'0=system stats'
||' '||'<aggr>=aggregate stats for all users'
,''
);
rem strig.sql
prompt Adding help for strig...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'strig'
,'display trigger body text'
,'@strig <%owner.trigger%>'
,'object:table:trigger'
,'sql'
,''
,''
,'@trigs'
);
rem submit.sql
prompt Adding help for submit...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'submit'
,'schedule a job to be executed'
,'@submit <interval> "<job>"'
,'job'
,'pls ddl'
,'<interval> format: [!][[+][dd<-|,>]hh[:mm]]'
||' '||'! means execute immediately'
||' '||'+ specifies a relative time (from current time)'
||' '||'dd, day of month or # days if relative (monthly)'
||' '||'dd- day of week or # days if relative (weekly)'
||' '||'hh  hours (daily)'
||' '||':mm minutes'
,'Use TWO single quotes around string parameters'
,'@daily @jc @jobs'
);
rem sview.sql
prompt Adding help for sview...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'sview'
,'dump view definition to screen'
,'@sview <%owner.view%>'
,'object:view'
,'sql'
,''
,''
,'@objs'
);
rem sy.sql
prompt Adding help for sy...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'sy'
,'connect as system'
,'@sy <db>'
,'misc'
,'sql'
,''
,''
,''
);
rem syncgrnt.sql
prompt Adding help for syncgrnt...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'syncgrnt'
,'synchronize grants between databases'
,'@syncgrnt <database> <%grantee%> <usertype> <priv> <grant_rev>'
,'security'
,'sql'
,''
,'<usertype>  = <UR|%>'
||' '||'<priv> = <SRT|%>'
||' '||'<grant_rev> = <GR|%>'
||' '||'- Does not effect SYS, SYSTEM, or system roles'
||' '||'- Does not create or drop USERS or ROLES'
||' '||'- Only grants or revoke is USER+ROLE+OBJECT exists in BOTH dbs'
||' '||'- Can only sync objects granted for current user'
,'@syncpwd'
);
rem syncpwd.sql
prompt Adding help for syncpwd...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'syncpwd'
,'synchronize user passwords between databases'
,'@syncpwd <database> <%users%> <%has_role%>'
,'security'
,'sql gen ddl dba'
,''
,'- Does not effect SYS'
||' '||'- Does not create or drop USERS'
,'@users'
);
rem syns.sql
prompt Adding help for syns...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'syns'
,'display user synonyms'
,'@syns <%owner.synonym%>'
,'object:synonym'
,'sql'
,''
,''
,'@pubs'
);
rem tabs.sql
prompt Adding help for tabs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'tabs'
,'list tables'
,'@tabs <%owner.table%> <%ts%>'
,'object:table'
,'sql'
,''
,''
,'@cons @idxs @objs @tabstat'
);
rem tabstat.sql
prompt Adding help for tabstat...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'tabstat'
,'list table statistics'
,'@tabstat <%owner.table%> <%ts%>'
,'object:table'
,'sql'
,''
,'Theses columns in SYS.DBA_TABLES are calculated by ANALYZE'
||' '||'NUM_ROWS	number of rows '
||' '||'BLOCKS		blocks below high-water mark'
||' '||'EMPTY_BLOCKS	blocks above high-water mark'
||' '||'AVG_SPACE	average free space in blocks below high-water'
||' '||'CHAIN_CNT	number of chained or migrated rows'
,''
);
rem trace.sql
prompt Adding help for trace...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'trace'
,'set sql_trace on/off in selected user sessions'
,'@trace <%user%> <%sid,serial#%> <true|false>'
,'tuning'
,'sql gen ddl'
,''
,''
,''
);
rem trigs.sql
prompt Adding help for trigs...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'trigs'
,'list triggers'
,'@triggers <%owner.table%> <%type%>'
,'object:table:trigger'
,'sql'
,''
,''
,''
);
rem trigs2.sql
prompt Adding help for trigs2...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'trigs2'
,'report summary of triggers by type and event'
,'@trigs2 <%owner.table%>'
,'object:table:trigger'
,'sql'
,''
,''
,''
);
rem trim.sql
prompt Adding help for trim...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'trim'
,'trim values in columns'
,'@trim <%owner.table%> <%columns%>'
,'data'
,'sql gen dml'
,''
,''
,'@trimu @upper'
);
rem trimu.sql
prompt Adding help for trimu...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'trimu'
,'trim values in columns and convert to uppercase'
,'@trims <%owner.table%> <%column%>'
,'data'
,''
,''
,''
,'@trim @upper'
);
rem trunc.sql
prompt Adding help for trunc...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'trunc'
,'drop database objects'
,'@trunc <%owner.table%> <%type%>'
,'object:table'
,'sql gen ddl'
,''
,'Use with caution'
,'@delete @drop'
);
rem ts.sql
prompt Adding help for ts...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'ts'
,'list tablespaces'
,'@ts'
,'database'
,'sql'
,''
,''
,'@frag'
);
rem uga.sql
prompt Adding help for uga...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'uga'
,'display user uga memory usage'
,'@uga <%user%> <%|minuga>'
,'tuning:memory'
,'sql'
,''
,''
,'@stats @uga'
);
rem uninst.sql
prompt Adding help for uninst...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'uninst'
,'uninstall sql library'
,'@uninst'
,'sqlplus'
,'sql'
,''
,''
,'@install'
);
rem unpin.sql
prompt Adding help for unpin...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'unpin'
,'un-pin objects in shared pool'
,'@unpin [owner.]object'
,'instance'
,'pls dba ddl'
,''
,''
,'@pin'
);
rem up.sql
prompt Adding help for up...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'up'
,'display up time of database'
,'@up'
,'instance'
,'sql dba n80'
,''
,''
,'@db'
);
rem updcols.sql
prompt Adding help for updcols...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'updcols'
,'display updatable columns in join views'
,'@updcols <%owner.view%> <%column%>'
,'object:view'
,'sql v72'
,''
,''
,'@cols'
);
rem updtab.sql
prompt Adding help for updtab...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'updtab'
,'execute lang_updtab.update_table procedure'
,'@updtab <dtab> <stab> <flags> <commitpoint>'
,'database'
,'sql'
,''
,'See LANG_UPDTAB package for details'
,''
);
rem upper.sql
prompt Adding help for upper...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'upper'
,'trim values in columns'
,'@upper <%owner.table%> <%columne%>'
,'data'
,'sql'
,''
,''
,'@trim @trimu'
);
rem usage.sql
prompt Adding help for usage...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'usage'
,'show session usage'
,'@usage'
,'session'
,'sql'
,''
,'enh: this is a simple script, needs more info'
,'@lic @sess'
);
rem userenv.sql
prompt Adding help for userenv...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'userenv'
,'show values of all userenv variables'
,'@userenv'
,'user'
,'sql v73'
,''
,'Valid USERENV parameters are:'
||' '||'OSDBA, LABEL*, LANGUAGE, TERMINAL, SESSIONID*, ENTRYID*'
||' '||'CLIENT_INFO, LANG'
||' '||'*restricted, see documentation'
||' '||'SESSIONID,ENTRYID require AUDIT_TRAIL=TRUE in init.ora'
,''
);
rem users.sql
prompt Adding help for users...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'users'
,'this script displays users accounts (granted listed roles)'
,'@users <%username%> <%role%>'
,'user'
,'sql dba'
,''
,''
,'@roles'
);
rem ver.sql
prompt Adding help for ver...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'ver'
,'show product version information and installed options'
,'@ver'
,'database'
,'sql'
,''
,''
,''
);
rem vsize.sql
prompt Adding help for vsize...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'vsize'
,'display vsize of column'
,'@vsize <table> <column>'
,'object'
,'sql'
,''
,''
,''
);
rem waiters.sql
prompt Adding help for waiters...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'waiters'
,'list users waiting for locks'
,'@waiters'
,'tuning'
,'sql'
,''
,'Requires catblock.sql to be executed as SYS'
,''
);
rem waits.sql
prompt Adding help for waits...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'waits'
,'show session waits'
,'@waits <%user%>'
,'tuning'
,'sql dba'
,''
,''
,''
);
rem whatis.sql
prompt Adding help for whatis...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'whatis'
,'resolve reference to specified name from current account'
,'@whatis <name>'
,'object'
,'sql'
,''
,'resolution stops if object is in another database'
||' '||'Tells you what object <name> actually refers to'
,''
);
rem who.sql
prompt Adding help for who...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'who'
,'display username and database'
,'@who <%user%>'
,'session'
,''
,''
,''
,'@finger'
);
rem whoami.sql
prompt Adding help for whoami...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'whoami'
,'display current username and database'
,'@whoami'
,'session'
,'sql'
,''
,''
,''
);
rem whoamip.sql
prompt Adding help for whoamip...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'whoamip'
,'set sqlprompt to "<user>@<database>> "'
,'@whoamip'
,'sqlplus'
,'sql nst'
,''
,'Set in LOGIN.SQL or GLOGIN.SQL to set SQLPROMPT'
||' '||'initially.  Use @conn to connect within SQL*Plus.'
,'@conn'
);
rem y2k.sql
prompt Adding help for y2k...
insert into lang_sql_help
(name,purpose,usage,subject,attrib,descr,notes,seealso)
values (
'y2k'
,'simple script to check date conversion'
,'@y2k <date_string>'
,'nls'
,'sql'
,''
,''
,'@nls'
);
select 'Help for '||count(*)||' scripts created.' from lang_sql_help;
quit
