rem Author:  Mark Lang, 1998
rem Name:    idxs.sql
rem Purpose: List indexes
rem Usage:   @idxs <%owner.table%> <%index%>
rem Subject: object:table:index
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @idxstat @segsi
rem History:
rem          01-feb-98  Initial release

@setup1

define idx="upper('&&2')"

column tname format a25 heading "TABLE_NAME"
column columns format a53 heading "INDEX"

select
  i.table_owner||'.'||i.table_name tname,
  decode(i.status,'VALID','','('||i.status||') ')||
  decode(i.uniqueness, 'NONUNIQUE', '', i.uniqueness||' ')||
  decode(i.owner, i.table_owner, '', i.owner||'.')||
  i.index_name||
  '('||&&sqllib..column_list(i.owner, i.index_name, 'INDEX')||')' 
    columns
from &&ora._indexes i
where i.table_owner like &&o1
and i.table_name like &&n1
and i.index_name like &&idx
order by table_owner,table_name,index_name
;

undef idx

@setdefs

