rem Author:  Mark Lang, 1998
rem Name:    idxstat.sql
rem Purpose: List index statistics
rem Usage:   @idxstat <%owner.table%> <%index%>
rem Subject: object:table:index
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @idxs
rem History:
rem          01-feb-98  Initial release

@setup1

define idx="upper('&&2')"

column iname format a40 heading "INDEX_NAME"
column blevel format 9 heading "DP"
column leaf_blocks format 99,999 heading "LEAF|BLK"
column distinct_keys format 99,999,999 heading "DIST KEY"
column avg_leaf_blocks_per_key format 99 heading "L/K" justify center
column avg_data_blocks_per_key format 99 heading "B/K" justify center
column clustering_factor format 99,999 heading "CLUSFAC"


select
  i.table_owner||'.'||i.table_name||'.'||i.index_name iname,
  blevel,
  leaf_blocks,
  distinct_keys,
  avg_leaf_blocks_per_key,
  avg_data_blocks_per_key,
  clustering_factor
from &&ora._indexes i
where i.table_owner like &&o1
and i.table_name like &&n1
and i.index_name like &&idx
order by i.table_owner, i.index_name
;

undef idx

@setdefs

