rem Author:  Mark Lang, 1998
rem Name:    initora.sql
rem Purpose: Create database init.ora
rem Usage:   @initora <opts>
rem Subject: instance
rem Attrib:  sql out dba
rem Descr:
rem Notes:
rem          <opts>
rem          0=print all
rem          1=print all, comment defaults
rem	     2=print only non-defaults
rem SeeAlso:
rem History:
rem          01-feb-98  Initial release

@setup
set heading off
define opts="&&1"

set termout off
column name new_value db
select name from v$database;
column name clear
set termout on

spool init&&db..ora

select
  '#INIT.ORA for database '||d.name||chr(10)||
  '#Generated On: '||to_char(sysdate, 'DD-MON-YY HH24:MI:SS')
from v$database d
;

prompt

select
  decode(to_number(&&opts),
    1, decode(isdefault, 'TRUE', '#', decode(value, null, '#', '')),
    decode(value, NULL, '#', ''))||name||'='||value
FROM v$parameter
where to_number(&&opts) < 2 or isdefault = 'TRUE'
order by name
;

spool off

undef db opts

@setdefs

