rem Author:  Mark Lang, 1998
rem Name:    install.sql
rem Purpose: Installed SQL library globally
rem Usage:   @install
rem Subject: sqlplus
rem Attrib:  sql
rem Descr:
rem Notes:   Recommend to use SYSTEM account (not SYS)
rem SeeAlso: @uninst
rem History:
rem          04-feb-98  Dont allow to run as SYS
rem          01-feb-98  Initial release

@setup
set heading off
prompt SQL LIBRARY INSTALLATION
prompt

accept ityp char prompt "Local or Global install (l/G)? "
prompt
accept ihlp char prompt "Install HELP table (n/Y)? "

define typ="upper(nvl('&&ityp','G'))"
define hlp="upper(nvl('&&ihlp','Y'))"

column text format a79

set termout off
spool install.tmp
select
  decode(&&typ, 'G',
  'prompt Setting up account for global use...'
  ||chr(10)||'grant select any table to '||user||';')
||chr(10)||'prompt Creating package(s)...'
||chr(10)||'@langutil.sql'
||chr(10)||'@langutil.bdy'
||decode(&&typ, 'G',
    chr(10)||'prompt Making availble to PUBLIC...'
  ||chr(10)||'drop public synonym lang_util;'
  ||chr(10)||'create public synonym lang_util for lang_util;'
  ||chr(10)||'grant execute on lang_util to public;'
)
||decode(&&hlp, 'Y',
  chr(10)||'prompt Creating HELP table(s)...'
  ||chr(10)||'@helpdrop.sql'
  ||chr(10)||'@helpbild.sql')
  text
from dual
where user != 'SYS';
select
  'prompt Do not install library as SYS!'||&&cr
  ||'prompt Use SYSTEM instead...'
from dual
where user = 'SYS';
spool off
set termout on

prompt
@doit
prompt
set feedback on
@install.tmp

undef dummy hlp typ ihlp ityp

@setdefs

