rem Author:  Mark Lang, 1998
rem Name:    invalid.sql
rem Purpose: Display database objects of some type
rem Usage:   @invalid <%owner.name%> <%type%>
rem Subject: plsql
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @compile
rem History:
rem          01-feb-98  Initial release

@setup1

column objname format a25 heading "OBJECT_NAME"
column object_type format a12 heading "TYPE"
column created heading "CREATED"
column last_ddl_time heading "LAST DDL"
column status heading "STATUS"

SELECT
  o.owner||'.'||o.object_name objname,
  o.object_type,
  o.created,
  o.last_ddl_time,
  o.status
FROM sys.dba_objects o
WHERE o.owner LIKE &&o1
AND o.object_name LIKE &&n1
AND o.object_type LIKE upper('&&2')
AND status = 'INVALID'
ORDER BY o.owner,o.object_name
;

@setdefs


