rem Author:  Mark Lang, 1998
rem Name:    jobs.sql
rem Purpose: Displays information about a job
rem Usage:   @jobs <%what%>
rem Subject: job
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @jc @submit
rem History:
rem          01-feb-98  Initial release


@setup

column job 	  format 990
column schema	  format a12
column next_date  format a15
column broken	  format a1  heading "B"
column failures	  format 990 heading "FAIL"
column total_time format 9990.99 heading "TIME"
column what	  format a30 wrap

select
log_user schema
,what
,job
,decode(this_date,
  null, to_char(next_date, 'Mon DD HH24:MI:SS'),
  'RUNNING'
) next_date
,total_time/60 total_time
,failures
,broken
from &&oru._jobs
where upper(what) like upper('&&1')
;

@setdefs




