rem Author:  Mark Lang, 1998
rem Name:    keys.sql
rem Purpose: Display primary, unique, foreign keys on table or column
rem Usage:   @keys <%owner.table%> <%type%> <%column%>
rem Subject: object
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @cons @refs
rem History:
rem          01-feb-98  Initial release

@setup1

define typ="upper(replace('&&2','%','PUR'))"
define col="upper('&&3')"

column status format a2 heading "SD"
column cname format a30 heading "Name"
column constraint format a44 WORD heading "Constraint"

SELECT
  substr(c.status, 1, 1)||
    substr(c.delete_rule, 1, 1) status
  ,c.owner||'.'||c.table_name||'.'||c.constraint_name cname
  ,DECODE(c.constraint_type,
    'P', 'PRIMARY KEY',
    'U', 'UNIQUE',
    'R', 'FOREIGN KEY',
    ''
  )||
  ' ('||&&sqllib..column_list(c.owner, c.constraint_name, 'CONSTRAINT')||')'
  ||DECODE(c.constraint_type,
    'R', ' REFERENCES '||r.table_name||' ('||
         &&sqllib..column_list(r.owner, r.constraint_name, 'CONSTRAINT')||')',
    ''
  )
  constraint
from &&ora._constraints c, &&ora._constraints r
where c.owner like &&o1
and c.table_name like &&n1
and c.constraint_type in ('P', 'U', 'R')
and instr(&&typ, c.constraint_type) > 0
and c.r_owner = r.owner(+)
and c.r_constraint_name = r.constraint_name(+)
and exists (
  select 0
  from &&ora._cons_columns
  where owner=c.owner
  and constraint_name=c.constraint_name
  and column_name like &&col
);

undef typ col

@setdefs

