rem 10-feb-98 removed RNPS pragma from column_list and storage
rem because of bug in Oracle 7.3.2

create or replace package lang_util as

function version return varchar2;
pragma restrict_references(version,wnds,wnps,rnds,rnps);


/* Formatting */
function element(
  str varchar2
, delim varchar2 default ' '
, elem number default 1
, quote varchar2 default null
) return varchar2;
pragma restrict_references(element, wnds, wnps, rnps, rnds);

/* Data Dictionary */
function default_value(objown varchar2, objnam varchar2, colnam varchar2)
  return varchar2;
pragma restrict_references (default_value, wnds, wnps, rnps);

function rtable(cown varchar2, cnam varchar2) return varchar2;
pragma restrict_references(rtable, wnds, wnps, rnps);

function scond(cown varchar2, cnam varchar2) return varchar2;
pragma restrict_references(scond, wnds, wnps, rnps);

function storage(
  objown varchar2
, objnam varchar2
, objtyp varchar2
, newts varchar2 default '*'
, compres number default 0
, delim varchar2 default chr(10)
) return varchar2;
pragma restrict_references(storage, wnds, wnps, rnps);

function column_list (
  objown varchar2
, objnam varchar2
, objtyp varchar2 default 'TABLE'
, objcol varchar2 default '%'
, orderby number default 0      -- 0=id, else name
, fmt1 varchar2 default '?'
, fmtn varchar2 default ',*'
, maxlen number default 0
, exclcols varchar2 default null
) return varchar2;
pragma restrict_references(column_list, wnps, wnds);

function shortname (v_owner varchar2, v_table varchar2)
  return varchar2;
pragma restrict_references(shortname, wnps, wnds);

function userid (uname varchar2) return number;
pragma restrict_references(userid, wnps, wnds, rnps);

function objid (
  objown varchar2
, objnam varchar2
, objtyp varchar2 default 'TABLE'
) return number;
pragma restrict_references(userid, wnps, wnds, rnps);

function object_exists(
  objown varchar2
, objnam varchar2
, objtyp varchar2 default 'TABLE'
) return boolean;
pragma restrict_references(object_exists, wnps, wnds, rnps);

function column_in_pk(town varchar2, tnam varchar2, col varchar2)
return number;
pragma restrict_references(column_in_pk, wnps, wnds, rnps);

function fmtk(num number, len number default 5, dec number default null)
return varchar2;
pragma restrict_references(fmtk, wnps, wnds);


end lang_util;
/

show errors package lang_util
