rem Author:  Mark Lang, 1998
rem Name:    lastsql.sql
rem Purpose: Display last executed SQL statement by session with stats
rem Usage:   @lastsql <%user%> <%status%>
rem Subject: session
rem Attrib:  sql dba
rem Descr:
rem Notes:
rem SeeAlso: @sqlarea
rem History:
rem          01-feb-98   Initial release

@setup

column username format a10
column status format a10
column text format a56 word
set long 2000

define usr="upper('&&1')"
define sta="upper('&&2')"

select
s.username
,s.status
,'(diskr='||l.disk_reads
||', bgets='||l.buffer_gets
||', opt='||l.optimizer_mode||':'||l.optimizer_cost 
||', rows='||l.rows_processed
||', sorts='||l.sorts
||', mem=s:'||l.sharable_mem||',p:'||l.persistent_mem||',r:'||l.runtime_mem
||')'||&&cr
||l.sql_text
  text
from v$session s, v$sql l
where s.sql_address = l.address
and s.username like &&usr
and s.status like &&sta
;

undef usr sta

@setdefs
