rem Author:  Mark Lang, 1998
rem Name:    like.sql
rem Purpose: Create an ORACLE user account like another account
rem Usage:   @like <new_user> <like_user>
rem Subject: user
rem Attrib:  sql
rem Descr:
rem Notes:   enh: rename script?
rem SeeAlso: @users
rem History:
rem          01-feb-98  Initial release

@setup
set heading off

define ue="select 0 from sys.dba_users where username = upper('&&1')"
define u2="grantee = upper('&&2')"

spool like.tmp
select
  'create user &&1 identified by &&1'||&&cr||
  'default tablespace '||default_tablespace||&&cr||
  'temporary tablespace '||temporary_tablespace||';'
from sys.dba_users u
where username = upper('&&2')
and not exists (&&ue)
;

rem Grants

select
  'grant '||privilege||' to &&1;'
from sys.dba_sys_privs p
where &&u2
;

select
  'grant '||granted_role||' to &&1;'
from sys.dba_role_privs p
where &&u2
;

select
  'grant '||privilege||' on '||owner||'.'||table_name||' to &&1;'
from sys.dba_tab_privs p
where &&u2
;

select
  'grant '||privilege||' on '||owner||'.'||table_name||
  '('||column_name||') to &&1;'
from sys.dba_col_privs p
where &&u2
;

spool off
set feedback on
@doit
@like.tmp

undef ue u2

@setdefs





