rem Author:  Mark Lang, 1998
rem Name:    longops.sql
rem Purpose: Display long running operations in V$SESSION_LONGOPS
rem Usage:   @longops
rem Subject: session
rem Attrib:  sql dba v80
rem Descr:
rem Notes:
rem SeeAlso: @sess @stats
rem History:
rem          01-feb-98  Initial release

@setup

define usr="upper('&&1')"

column username format a12
column compnam format a20 wrap
column sofar format 999990
column totalwork format 999990 heading "TOTAL"
column start_time format a12 heading "STARTTIME"
column progress format 0.999 heading "%"
column elapsed_minutes format 990.99 heading "ELAPS(M)"

select
s.username
,compnam
,sofar
,totalwork
,decode(totalwork,0,0,null,0,sofar/totalwork) progress
,to_char(start_time,decode(trunc(start_time),trunc(sysdate)
  ,'HH24:MI:SS','Dy HH24:MI')) start_time
,(elapsed_seconds)/60 elapsed_minutes
from v$session_longops l, v$session s
where l.sid=s.sid(+) and l.serial#=s.serial#(+)
and s.username(+) like &&usr
;

undef usr

@setdefs
