rem Author:  Mark Lang, 1998
rem Name:    lowcard.sql
rem Purpose: List indexes on low cardinality columns
rem Usage:   @lowcard <%owner.table%> <max_percent_distinct>
rem Subject: object:table:index
rem Attrib:  sql
rem Descr:
rem Notes:   Requires ANALYZE..STATISTICS on tables and indexes
rem          <pct>=distinct_keys/num_rows*100
rem SeeAlso: @idxstat
rem History:
rem          01-feb-98  Initial release

@setup1

define pct="to_number(replace('&&2','%','1'))"

column iname format a40 heading "INDEX_NAME"
column blevel format 9 heading "DP"
column leaf_blocks format 99,999 heading "LEAF|BLK"
column num_rows format 9,999,990 heading "ROWS"
column distinct_keys format 9,999 heading "KEYS"
column avg_leaf_blocks_per_key format 99 heading "L/K" justify center
column avg_data_blocks_per_key format 99 heading "B/K" justify center

select
  i.table_owner||'.'||i.table_name||'.'||i.index_name iname,
  blevel,
  leaf_blocks,
  t.num_rows,
  distinct_keys,
  avg_leaf_blocks_per_key,
  avg_data_blocks_per_key
from &&ora._indexes i, &&ora._tables t
where i.table_owner like &&o1
and i.table_name like &&n1
and i.table_owner=t.owner
and i.table_name=t.table_name
and decode(t.num_rows,0,0,(i.distinct_keys/t.num_rows*100))>0
and decode(t.num_rows,0,0,(i.distinct_keys/t.num_rows*100))<=&&pct
order by i.table_owner, i.index_name
;

undef pct

@setdefs

