rem Author:  Mark Lang, 1998
rem Name:    lrustat.sql
rem Purpose: Display buffer cache statistics in X$KCBRBH and X$KCBCBH
rem Usage:   @lrustat <interval>
rem Subject: tuning
rem Attrib:  sql sys
rem Descr:
rem Notes:   This script can only be run as SYS.
rem          Otherwise, you will get a "table or view does not exist" error.
rem SeeAlso: @hits @ratio
rem History:
rem          01-feb-98  Initial release

@setup

PROMPT Displays hit ratio based on increased or decreased buffer cache
PROMPT based on X$KCBRBH and X$KCBCBH tables.
PROMPT
PROMPT NOTE: This script can only be run as SYS.
PROMPT       Otherwise, you will get a "table or view does not exist" error.
PROMPT

COLUMN "Interval"   FORMAT A14
COLUMN "Cache Hits" FORMAT A12
COLUMN "Hit Ratio"  FORMAT A9

VAR n_a NUMBER
VAR n_b NUMBER
VAR n_c NUMBER
VAR n_d NUMBER
VAR n_e NUMBER
VAR n_f NUMBER

BEGIN
  SELECT
    SUM(DECODE(name, 'db block gets', value, 0)),
    SUM(DECODE(name, 'consistent gets', value, 0)),
    SUM(DECODE(name, 'physical reads', value, 0))
  INTO :n_a, :n_b, :n_c
  FROM v$sysstat;
  SELECT
    value,value
  INTO :n_d, :n_e
  FROM v$parameter
  WHERE name = 'db_block_buffers';
  SELECT
    (1-(:n_d/(:n_a+:n_b)))*100 INTO :n_f
  FROM sys.dual;
END;
/

SELECT
  TO_CHAR(&&1*TRUNC(indx/&&1)+1, '99990')||
    ' to '||
    TO_CHAR(DECODE(TRUNC(&&1*(TRUNC(indx/&&1)+1)/:n_d), 0,
            &&1*(TRUNC(indx/&&1)+1), :n_e), '99990') "Interval",
  TO_CHAR(SUM(count), '999,999,990') "Cache Hits",
  TO_CHAR(-(SUM(count)/(:n_a+:n_b))*100, '99990.99') "Hit Ratio"
FROM x$kcbcbh
GROUP BY TRUNC(indx/&&1);

SET HEADING OFF

SELECT
  TO_CHAR(:n_d, '9990') "Interval",
  TO_CHAR(:n_c, '999,999,990') "Cache Hits",
  TO_CHAR(:n_f, '99990.99') "Hit Ratio"
FROM sys.dual;

SELECT
  TO_CHAR(&&1*TRUNC(indx/&&1)+1, '9990')||
    ' to '||
    TO_CHAR(&&1*(TRUNC(indx/&&1)+1), '9990') "Interval",
  TO_CHAR(SUM(count), '999,999,990') "Cache Hits",
  TO_CHAR((SUM(count)/(:n_a+:n_b))*100, '99990.99') "Hit Ratio"
FROM x$kcbrbh
GROUP BY TRUNC(indx/&&1);

UNDEF 1

@setdefs

