rem Author:  Mark Lang, 1998
rem Name:    ls.sql
rem Purpose: UNIX-style list of objects
rem Usage:   @ls <%owner.name%>
rem Subject: object
rem Attrib:  sql
rem Descr:
rem Notes:   Can use UNIX-style wildcards (* and ?)
rem          enh: show privs rw-rw-rw-?
rem SeeAlso:
rem History:
rem          01-feb-98  Initial release

@setup1

column objname format a35 heading "OBJECT_NAME"
column object_type format a12 heading "TYPE"
column last_ddl_time format a10 heading "LAST_DDL"
column status heading "STATUS"

select
  lower(decode(o.owner, user, '.', o.owner)||'/'||o.object_name)||
    decode(o.object_type, 'SYNONYM', ' -> '||
    lower(
      decode(s.table_owner, user, '', s.table_owner||'/')||
      s.table_name||
      decode(s.db_link, null, '', '@'||s.db_link)
    ))
    objname
, lower(o.object_type) object_type
, to_char(o.last_ddl_time,
  decode(trunc(o.last_ddl_time)
  , trunc(sysdate), 'HH24:MI:SS'
  , 'Dy Mon DD'
  )) last_ddl_time
, lower(o.status) status
from sys.dba_objects o, sys.dba_synonyms s
where o.owner like &&o1
and o.object_name like &&n1
and o.owner = s.owner(+)
and o.object_name = s.synonym_name(+)
order by o.owner,o.object_name
;

@setdefs
