rem Author:  Mark Lang, 1998
rem Name:    miscols.sql
rem Purpose: Report missing columns in current database from another
rem Usage:   @miscols <%owner.name%> <%column_name%> <%data_type%> <db>
rem Subject: object:table:column
rem Attrib:  sql
rem Descr:
rem Notes:   Use in the database which is missing columns
rem SeeAlso: @miscons @misobjs
rem History:
rem          01-feb-98  Initial release
rem          28-jan-98  Display length if different

@setup1

define db1="@&&4"
define db2=""
define typ="upper('&&2')"
define col="upper('&&3')"
define cols="owner||'.'||table_name tname,column_name,data_type,nullable"

column tname format a25 heading "TABLE_NAME"
column column_name format a20
column data_type format a10
column data_length format 9990 heading "LEN"
column nullable format a3 heading "NULL"
column diff format a10

define diff="decode(c2.column_name,null,'NOT FOUND',decode(c2.data_type,c1.data_type,decode(c2.nullable,c1.nullable,decode(c2.data_length,c1.data_length,null,'LEN='||to_char(c2.data_length)),decode(c2.nullable,'Y','NULL','NOT NULL')),c2.data_type))"

select
  c1.owner||'.'||c1.table_name tname
, c1.column_name
, c1.data_type
, c1.data_length
, c1.nullable
, &&diff diff
from &&ora._tab_columns&&db1 c1, &&ora._tab_columns&&db2 c2
where c1.owner like &&o1
and c1.table_name like &&n1
and c1.column_name like &&col
and c1.data_type like &&typ
and c1.owner=c2.owner(+)
and c1.table_name=c2.table_name(+)
and c1.column_name=c2.column_name(+)
and &&diff is not null
;

undef db1 db2 ty col cols

@setdefs

