rem Author:  Mark Lang, 1998
rem Name:    mkexp.sql
rem Purpose: Create a table export .PAR file
rem Usage:   @mkexp <%owner.name%> <%tablespace%> <parfile>
rem Subject: database
rem Attrib:  sql gen
rem Descr:
rem Notes:   .PAR extension is NOT appened to <parfile>
rem          If owner is wildcarded then each table listed in
rem          <parfile> will be prefixed with "owner."
rem          File may require editing after generation, use this
rem          script to create prototype only
rem SeeAlso:
rem History:
rem          10-feb-98  Created


@setup1
set serveroutput on size 99999
set heading off
define ts="upper('&&2')"
define pf="&&3"

spool &&pf
declare
  i binary_integer:=0;
  t varchar2(128);
begin
  &&putl('tables(');
  for r in (
    select
      decode(instr(&&o1, '%'),
        0, '', owner||'.')||table_name
      name
    from &&ora._tables
    where owner like &&o1
    and table_name like &&n1
    and (tablespace_name like &&ts or tablespace_name is null)
  ) loop
    i := i + 1;
    t := r.name;
    if i > 1 then
      t := ','||t;
    end if;
    &&putl(t);
  end loop;
  &&putl(')');
end;
/
spool off

@setdefs


