rem Author:  Mark Lang, 1998
rem Name:    mtsmon.sql
rem Purpose: Monitor multi-threaded server activity
rem Usage:   @mtsmon <%|c|d|m|q|s>
rem Subject: mts
rem Attrib:  sql dba
rem Descr:
rem Notes:
rem SeeAlso:
rem History:
rem          01-feb-98  Initial release

@setup

define arg="upper('&&1')"

column name format a5
column network format a20 wrap
column status format a12
column accept format a3
column messages format 999,990
column kbytes format 999,990
column breaks format 990 heading "BRKS"
column requests format 999,990
column owner format 990
column created format 990
column idle format 999,999,990
column busy format 999,990
column listener format 990
column load format 0.999

column username format a12
column dispatcher format a5
column server format a5
column waiter format a5

select *
from v$mts
where 'M' like &&arg
;

select
name
--,network
,status
,accept
,messages
,bytes/1024 kbytes
,breaks
--,owned
--,created
,idle
,busy
--,listener
,busy/(idle+busy) load
from v$dispatcher
where 'D' like &&arg
;

select
name
,status
,messages
,bytes/1024 kbytes
,breaks
,requests
,idle
,busy
,busy/(idle+busy) load
from v$shared_server
where 'S' like &&arg
;

select
*
from v$queue
where 'Q' like &&arg
;

select
u.username
,d.name dispatcher
,s.name server
,w.name waiter
,c.bytes/1024 kbytes
,c.breaks
,c.status
,c.queue
from v$circuit c, v$session u, v$dispatcher d, v$shared_server s,
  v$shared_server w
where 'C' like &&arg
and c.saddr=u.saddr
and c.dispatcher=d.paddr
and c.server=s.paddr(+)
and c.waiter=w.paddr(+)
order by u.username
;

undef arg

@setdefs

