rem Author:  Mark Lang, 1998
rem Name:    noaccess.sql
rem Purpose: Lists items which have no grants
rem Usage:   @noaccess <%owner.name%>
rem Subject: security
rem Attrib:  sql dba
rem Descr:
rem Notes:
rem SeeAlso: @privs
rem History:

@setup1

column name format a30

select
  owner||'.'||object_name name,
  object_type
from sys.dba_objects o
where o.owner like &&o1
and o.object_name like &&n1
and o.object_type not in ('INDEX', 'SYNONYM', 'TRIGGER', 'DATABASE LINK')
and not exists (
  select *
  from sys.dba_tab_privs
  where owner = o.owner and table_name = o.object_name
)
;

@setdefs

