rem Author:  Mark Lang, 1998
rem Name:    nofk.sql
rem Purpose: Show tables with no foreign key relationships
rem Usage:   @nofk <%owner.table%>
rem Subject: quality
rem Attrib:  sql
rem Descr:
rem Notes:   Table has no foreign keys in or out
rem SeeAlso: @cons @nopk
rem History:
rem          01-feb-98  Initial release

@setup1

column tname format a30

select
owner||'.'||table_name tname
from &&ora._tables t
where owner like &&o1
and table_name like &&n1
and not exists (
  select 0
  from &&ora._constraints c
  where owner=t.owner
  and table_name=t.table_name
  and constraint_type='R'
)
and not exists (
  select 0
  from &&ora._constraints c, &&ora._constraints r
  where c.owner=t.owner
  and c.table_name=t.table_name
  and c.constraint_type in ('P','U')
  and c.owner=r.r_owner
  and c.constraint_name=r.r_constraint_name
);

@setdefs
