rem Author:  Mark Lang, 1998
rem Name:    nullcols.sql
rem Purpose: List columns in tables which are all NULL
rem Usage:   @nullcols <%owner.table%> <%colname> <%data_type%>
rem Subject: data
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso:
rem History:
rem          01-feb-98  Initial release

@setup1
set heading off

define col="upper('&&2')"
define dat="upper('&&3')"

set termout off
spool nullcols.tmp

select
  'select '''||t.owner||'.'||t.table_name||'.'||t.column_name||' is all null'''||&&cr||
  'from sys.dual '||&&cr||
  'where not exists ('||&&cr||
  'select 0 '||'from '||t.owner||'.'||t.table_name||&&cr||
  'where '||t.column_name||' is not null'||');'
from sys.dba_tab_columns t
where t.owner like &&o1
and t.table_name like &&n1
and t.column_name like &&col
and t.data_type like &&dat
order by owner, table_name, column_name
;

spool off
set termout on
@nullcols.tmp

undef col dat

@setdefs
