rem Author:  Mark Lang, 1998
rem Name:    objs.sql
rem Purpose: Display database objects of some type
rem Usage:   @objs <%owner.name%> <%type%>
rem Subject: object
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @objs2
rem History:
rem          01-feb-98  Initial release
rem          16-jul-98  Display OBJECT_ID


@setup1
define typ="upper('&&2')"

column objname format a30 heading "OBJECT_NAME"
column object_type format a12 heading "TYPE"
column created heading "CREATED"
column last_ddl_time heading "LAST_DDL"
column status heading "STATUS"
column object_id heading "OBJ#" format 99990

select
  o.owner||'.'||o.object_name objname,
  o.object_type,
  o.created,
  o.last_ddl_time,
  o.status,
  o.object_id
from &&ora._objects o
where o.owner like &&o1
and o.object_name like &&n1
and o.object_type like &&typ
order by o.owner,o.object_name
;

undef typ

@setdefs
