rem Author:  Mark Lang, 1998
rem Name:    objs2
rem Purpose: Display summary of database objects by type
rem Usage:   @objs2 <%owner.name%> <%type%>
rem Subject: object
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @objs
rem History:

@setup1

define typ="upper('&&2')"

column owner       format a15    heading "OWNER"
column object_type format a15    heading "OBJECT TYPE"
column cnt         format 999990 heading "TOTAL"
column valid       format 999990 heading "VALID"
column invalid     format 999990 heading "INVALID"

select
  o.owner
, o.object_type
, count(*) cnt
, sum(decode(status, 'VALID', 1, 0)) valid
, sum(decode(status, 'INVALID', 1, 0)) invalid
from &&ora._objects o
where o.owner like &&o1
and o.object_name like &&n1
and o.object_type like &&typ
group by o.owner, o.object_type
;

undef typ

@setdefs
