rem Author:  Mark Lang, 1998
rem Name:    parts.sql
rem Purpose: List table partitions
rem Usage:   @parts <%owner.table%> <%ts%>
rem Subject: object:table:partition
rem Attrib:  sql v80
rem Descr:
rem Notes:   
rem SeeOnly: partstat.sql
rem History:
rem          01-feb-98  Initial release

@setup1
define ts="upper('&&2')"

column tname format a30 heading "TABLE_NAME"
column pname format a20 heading "PARTITION"
column tablespace_name format a15 heading "TABLESPACE"
column pctfu format a5
column trans format a5
column pct_increase format 990 heading "%INC"

select
  table_owner||'.'||table_name tname
, partition_name pname
, tablespace_name
, ltrim(to_char(pct_free))||'/'||ltrim(to_char(pct_used)) pctfu
, ltrim(to_char(ini_trans))||'/'||ltrim(to_char(max_trans)) trans
from &&ora._tab_partitions t
where table_owner like &&o1
and table_name like &&n1
and tablespace_name like &&ts
order by table_owner, table_name, partition_position
;

undef ts

@setdefs
