rem Author:  Mark Lang, 1998
rem Name:    pga.sql
rem Purpose: Display user PGA memory usage
rem Usage:   @pga <%user%> <%|minpga>
rem Subject: tuning:memory
rem Attrib:  sql dba
rem Descr:
rem Notes:
rem SeeAlso: @stats @uga
rem History:
rem          01-feb-98  Initial release

@setup

define usr="upper('&&1')"
define min="to_number(decode('&&2','%','0','&&2'))"

column username format a20
column pga format 999,999,990 heading "PGA"
column pmx format 999,999,990 heading "PGA MAX"
column pct format 0.990 heading "%MAX"

select
  s.username
, tpga.value pga
, tpmx.value pmx
, tpga.value/tpmx.value pct
from v$session s
, v$sesstat  tpga
, v$statname npga
, v$sesstat  tpmx
, v$statname npmx
where s.username like &&usr
and tpga.sid = s.sid and tpga.statistic# = npga.statistic# and npga.name = 'session pga memory'
and tpmx.sid = s.sid and tpmx.statistic# = npmx.statistic# and npmx.name = 'session pga memory max'
and tpga.value >= &&min
order by decode(&&min, 0, s.username, lpad(tpga.value, 15))
;

undef usr min

@setdefs
