rem Author:  Mark Lang, 1998
rem Name:    privs.sql
rem Purpose: Display privilegs granted to a users or role
rem Usage:   @privs <%grantee%> <%type%> <%privilege%> <%owner.table%>
rem Subject: security
rem Attrib:  sql dba
rem Descr:
rem Notes:   <type>=<SRTC|%> S=system R=role T=table C=column
rem          Unless you are DBA all privs may not be displayed
rem SeeAlso:
rem History:
rem          03-feb-98  Modified to support non-dba views
rem          01-feb-98  Initial release

@setup4
define grt="upper('&&1')"
define typ="replace(upper('&&2'),'%','SRTC')"
define prv="upper('&&3')"

column sortby       noprint
column grantee      format a20
column priv_type    format a1
column privilege    format a20
column oname        format a30
column options      format a2

select
1 sortby
,&&prvgrt grantee
,'S' priv_type
,privilege
,decode(admin_option, 'YES', 'A', '') options
,'' oname
from &&oru._sys_privs p
where &&prvgrt like &&grt
and instr(&&typ, 'S') > 0
and privilege like &&prv
union all
select
2 sortby
,&&prvgrt
,'R'
,granted_role
,decode(admin_option, 'YES', 'A', '')||
  decode(default_role, 'YES', 'D', '') options
,''
from &&oru._role_privs p
where &&prvgrt like &&grt
and instr(&&typ, 'R') > 0
and granted_role like &&prv
union all
select
3 sortby
,grantee
,'T'
,privilege
,decode(grantable, 'YES', 'G', '') options
,&&prvown||'.'||table_name
from &&ora._tab_privs p
where grantee like &&grt
and instr(&&typ, 'T') > 0
and privilege like &&prv
and &&prvown like &&o4
and table_name like &&n4
union all
select
3 sortby
,grantee
,'C'
,privilege
,decode(grantable, 'YES', 'G', '') options
,&&prvown||'.'||table_name||'.'||column_name
from &&ora._col_privs p
where grantee like &&grt
and instr(&&typ, 'C') > 0
and privilege like &&prv
and &&prvown like &&o4
and table_name||'.'||column_name like &&n4
order by 1,2,4,5;

undef grt typ prv

@setdefs
