rem Author:  Mark Lang, 1998
rem Name:    qaidxs.sql
rem Purpose: Remove redundant indexes from tables
rem Usage:   @qaidxs <%owner.table%>
rem Subject: quality
rem Attrib:  sql gen ddl
rem Descr:   Index is redundant if another composite index exists which is
rem          prefixed with the same columns
rem Notes:
rem SeeAlso: @idxs @qacons
rem History:
rem          01-feb-98  Initial release

@setup1

spool qaidxs.tmp

select
'drop index '||i.owner||'.'||i.index_name||';'
from &&ora._indexes i
where not exists (
  select 0
  from &&ora._indexes
  where table_owner=i.table_owner
  and table_name=i.table_name
  and &&sqllib..column_list(owner,index_name,'INDEX') like
    &&sqllib..column_list(i.owner,i.index_name,'INDEX')||'%'
);

spool off
@doit
set feedback on
@qaidxs.tmp
@setdefs
