rem Author:  Mark Lang, 1998
rem Name:    quotas.sql
rem Purpose: Use this as s quotas for creating scripts
rem Usage:   @quotas <%user%> <%ts%|0> <min_used_kb|%>
rem Subject: user
rem Attrib:  sql dba
rem Descr:
rem Notes:   <ts>=0 shows total quota used for all tablespaces
rem          If <min_used_kb> > 0 then sort by used
rem SeeAlso:
rem History:
rem          01-feb-98  Initial release

@setup

define us="UPPER('&&1')"
define ts="UPPER('&&2')"
define mx="to_number(decode('&&3','%','0','&&3'))*1024"
define qfmt="'99,999,999,990'"

column username format a15
column tspace format a15
column c_bytes format a15
column c_max_bytes format a30

select
  username,
  tablespace_name tspace,
  to_char(bytes, &&qfmt) c_bytes,
  decode(max_bytes, -1, 'UNLIMITED',
    TO_CHAR(max_bytes, &&qfmt)) c_max_bytes
from sys.dba_ts_quotas
where &&ts <> '0'
and username like &&us
and tablespace_name like &&ts
and bytes>=&&mx
order by decode(&&mx,0,username,lpad(to_char(bytes),10))
;

select
  username,
  'ALL' tspace,
  to_char(sum(bytes), &&qfmt) c_bytes,
  decode(sign(min(max_bytes)),
    -1, decode(sign(max(max_bytes)),
          -1, 'UNLIMITED',
          'UNLIMITED, '||ltrim(to_char(sum(max_bytes),&&qfmt))
        ),
    ltrim(to_char(sum(max_bytes),&&qfmt))
  ) c_max_bytes
from sys.dba_ts_quotas
where &&ts = '0'
and username like &&us
and bytes>=&&mx
group by username
;

undef us ts mx qmft

@setdefs
