rem Author:  Mark Lang, 1998
rem Name:    rbsstat.sql
rem Purpose: Display Rollback segments with tuning information
rem Usage:   @rbsstat <%rbsname%>
rem Subject: database
rem Attrib:  sql dba
rem Descr:
rem Notes:
rem SeeAlso: @rbs
rem History:
rem          11-feb-98  Initial release

@setup
set arraysize 2
define rbs="upper('&&1')"

prompt Tips on tuning rollback segments
prompt
prompt .          Avg Sizes,
prompt Shrinks    Shrunk     Analysis and Recommendation
prompt ---------  ---------  -------------------------------------------------+
prompt Low        Low        If "Avg. Sizes", "Active" is close to "Sizes,
prompt .                     Optimal" then the OPTIMAL settings is corrent.
prompt .                     Otherwise, OPTIMAL is too large (not many shrinks)
prompt
prompt Low        High       Excellent: a good setting for OPTIMAL
prompt
prompt High       Low        OPTIMAL is too small: too many shrinks
prompt
prompt High       High       Periodic long transactions are probably causing
prompt .                     these statistics.  Set the OPTIMAL parameter
prompt .                     higher until "Shrinks" is low.
prompt

column name format a6
column p format a1
column tablespace_name format a8
column onl format a1 heading "O"
column i# format 90
column extents format a4 heading "EXT"
column rssize format a4 heading "SIZE"
column writes format a4 heading "WRIT"
column xacts format a4 heading "XAC"
column gets format a4 heading "GETS"
column waits format a4 heading "WAIT"
column optsize format a4 heading "OPTSZ"
column hwmsize format a4 heading "HWMSZ"
column shrinks format a4 heading "SHRI"
column wraps format a4 heading "WRAP"
column extends format a4 heading "EXTS"
column aveshrink format a4 heading "ASHR"
column aveactive format a4 heading "AACT"

select
  un.name
, decode(un.user#,1,'Y','N') P
, ts.name tablespace_name
, decode(vr.status, 'ONLINE','Y','N') onl
, &&sqllib..fmtk(vr.extents,4) extents
, &&sqllib..fmtk(vr.rssize,4) rssize
, &&sqllib..fmtk(vr.writes,4) writes
--, &&sqllib..fmtk(vr.xacts,4) xacts
, &&sqllib..fmtk(vr.gets,4) gets
, &&sqllib..fmtk(vr.waits,4) waits
, &&sqllib..fmtk(vr.optsize,4) optsize
, &&sqllib..fmtk(vr.hwmsize,4) hwmsize
, &&sqllib..fmtk(shrinks, 4) shrinks
, &&sqllib..fmtk(wraps, 4) wraps
, &&sqllib..fmtk(extends, 4) extends
, &&sqllib..fmtk(vr.aveshrink,4) aveshrink
, &&sqllib..fmtk(vr.aveactive, 4) aveactive
from sys.undo$ un, sys.seg$ s, sys.ts$ ts, v$rollstat vr
where un.name like &&rbs
and un.file# = s.file# (+)
and un.block# = s.block# (+)
and s.type = 1
and s.ts# = ts.ts#
and un.us# = vr.usn
;

undef rbs
set arraysize 15
@setdefs

