rem Author:  Mark Lang, 1998
rem Name:    refs.sql
rem Purpose: Display foreign keys which references specified tables
rem Usage:   @refs <%r_owner.r_table%> <%owner.table%>
rem Subject: object:table:constraint
rem Attrib:  sql 
rem Descr:
rem Notes:
rem SeeAlso: @cons
rem History:
rem          01-feb-98  Initial release

@setup2

column tab_name format a30 heading "TABLE"
column con_name format a48 heading "CONSTRAINT"

select
  c.owner||'.'||c.table_name tab_name,
  'FOREIGN KEY ('||
    &&sqllib..column_list(c.owner, c.constraint_name,'CONSTRAINT')||
    ') REFERENCES '||c2.owner||'.'||c2.table_name||' ('||
    &&sqllib..column_list(c.r_owner, c.r_constraint_name,'CONSTRAINT')||') '
    ||decode(c.delete_rule,'CASCADE',' ON DELETE CASCADE','')
  con_name
from &&ora._constraints c, &&ora._constraints c2
where c.constraint_type='R'
and c.r_owner=c2.owner
and c.r_constraint_name=c2.constraint_name
and c.owner like &&o2
and c.table_name like &&n2
and c2.owner like &&o1
and c2.table_name like &&n1
;

@setdefs

