rem Name:    restrefs.sql
rem Purpose: Restore FK references saved in SAVED_CONSTRAINTS
rem Usage:   @restrefs <%owner.table%>
rem Subject: misc
rem Attrib:  pls dyn ddl
rem Descr:
rem Notes:
rem SeeAlso: @saverefs
rem History:
rem          23-mar-98  Initial release


@setup1
@output

declare

i binary_integer:=0;
j binary_integer:=0;
stmt varchar2(2000);

function exec(stmt varchar2)
return number is
  i number;
  retval number;
begin
  i := sys.dbms_sql.open_cursor;
  sys.dbms_sql.parse(i, stmt, sys.dbms_sql.v7);
  retval := sys.dbms_sql.execute(i);
  sys.dbms_sql.close_cursor(i);
  return retval;
end;


begin
 
for r in (
select *
from saved_constraints
where r_owner like &&o1
and r_table_name like &&n1
) loop
  stmt:=r.constraint_text;
  --sys.dbms_output.put_line(stmt);
  begin
    if exec(stmt) = 0 then
      i:=i+1;
      sys.dbms_output.put_line('Constraint restored.'); 
    end if;
  exception
    when others then
      sys.dbms_output.put_line('Failed to restore constraint '
        ||r.constraint_name||' on table '
        ||r.owner||'.'||r.table_name);
      sys.dbms_output.put_line(substr(sqlerrm,1,240));
  end;
  j:=j+1;
end loop;
sys.dbms_output.put_line(to_char(i)||' of '
  ||to_char(j)||' constraint(s) enabled.');
end;
/

@setdefs

