rem Author:  Mark Lang, 1998
rem Name:    rvobj.sql
rem Purpose: Revoke access to objects from users or roles
rem Usage:   @rvobj <%privilege%>[*] <%owner.name%> <%user|role%>
rem Subject: security
rem Attrib:  sql gen ddl own
rem Descr:
rem Notes:   Use with caution!
rem          * forces cascade constraints when REVOKE REF..
rem SeeAlso: @grobj @privs
rem          11-feb-98  Initial release

@setup2
set heading off

define prv="replace(upper('&&1'),'*')"
define usr="upper('&&3')"
define cas="instr('&&1','*')"

spool rvobj.tmp
select
  'revoke '||p.privilege||' on '||p.owner||'.'||p.table_name||
  ' from '||p.grantee
  ||decode(&&cas, 0, '', ' cascade constraints')
  ||';'
from user_tab_privs p
where p.grantor = user
and p.grantee like &&usr
and p.owner like &&o2
and p.table_name like &&n2
and (&&prv = 'ALL' or p.privilege like &&prv)
group by p.owner, p.table_name, p.privilege, p.grantee
;

spool off

@doit
set feedback on
@rvobj.tmp
@setdefs
