rem Name:    saveidxs.sql
rem Purpose: Save index definitions in SAVE_INDEXES table
rem Usage:   @saveidxs <table> <index> <uniqueness/type>
rem Subject: misc
rem Attrib:  sql dyn ddl
rem Descr:
rem Notes:
rem SeeAlso:
rem          23-mar-98  Initial release


@setup

create table saved_indexes (
owner varchar2(30)
,table_name varchar2(30)
,index_name varchar2(30)
,text varchar2(2000)
);

declare


function exec(stmt varchar2)
return number is
  i number;
  retval number;
begin
  i := sys.dbms_sql.open_cursor;
  sys.dbms_sql.parse(i, stmt, sys.dbms_sql.v7);
  retval := sys.dbms_sql.execute(i);
  sys.dbms_sql.close_cursor(i);
  return retval;
end exec;


procedure doit(stmt varchar2)
is
  retval number;
begin
  retval:=exec(stmt);
end;


procedure save_indexes(v_owner varchar2, v_table varchar2 default '%',
  v_index varchar2 default '%', v_type varchar2 default '%',
  save_tab varchar2 default 'SAVED_INDEXES')
is
  col varchar2(2000);
  cmd varchar2(2000);
  m varchar2(30);
begin
  for r in (
    select *
    from &&ora._indexes
    where table_owner like upper(v_owner)
    and table_name like upper(v_table)
    and index_name like upper(v_index)
    and uniqueness like upper (v_type)
    order by table_owner, table_name
  ) loop
    cmd := 'delete from '||save_tab||' where owner='''||r.owner||''''||
      ' and table_name='''||r.table_name||''''||
      ' and index_name='''||r.index_name||'''';
    doit(cmd);
    col := '';
    for s in (
      select decode(column_position,1,'',',')||column_name name 
      from &&ora._ind_columns
      where index_owner = r.owner
      and index_name = r.index_name
      order by column_position
    ) loop
      col := col||s.name;
    end loop;

    if r.uniqueness = 'NONUNIQUE' then
      m := '';
    else
      m := r.uniqueness;
    end if;

    cmd :=
      'insert into '||save_tab||' (owner,table_name,index_name,text) '||
      'values ('''||r.owner||''','''||r.table_name||''','''||
        r.index_name||''','''||
      'CREATE '||m||' index '||r.index_name||
      ' ON '||r.owner||'.'||r.table_name||' ('||col||') '||
      ' PCTFREE '||r.pct_free||
      ' TABLESPACE '||r.tablespace_name||
      ' STORAGE (initial '||r.initial_extent||' NEXT '||r.next_extent||
      ' PCTINCREASE '||r.pct_increase||') '||
      ''')';
    doit(cmd);
  end loop;
end;

begin
save_indexes(user,'&&1','&&2','&&3');
end; 
/


set feedback on
select table_name,index_name from saved_indexes;

@setdefs

