rem Name:    saverefs.sql
rem Purpose: Save foreign keys which references specified tables
rem Usage:   @saverefs <%r_owner.r_table%> <%owner.table%>
rem Subject: misc
rem Attrib:  sql dyn ddl
rem Descr:
rem Notes:   Table name is SAVED_CONSTRAINTS
rem SeeAlso: @cons @droprefs @refs @restrefs
rem History:
rem          23-mar-98  Initial release


@setup2.sql
@output

set termout off
create table saved_constraints (
owner varchar2(30)
,constraint_name varchar2(30)
,constraint_type varchar2(1)
,table_name varchar2(30)
,r_owner varchar2(30)
,r_constraint_name varchar2(30)
,r_table_name varchar2(30)
,delete_rule varchar2(9)
,status varchar2(8)
,constraint_text varchar2(2000)
);
set termout on

COLUMN tab_name FORMAT a30 HEADING "TABLE"
COLUMN con_name FORMAT a48 HEADING "CONSTRAINT"

declare
  i binary_integer:=0;
begin

for r in (
select
c.*
,c2.table_name r_table_name
,'alter table '||c.owner||'.'||c.table_name 
  ||' add constraint '||c.constraint_name||' foreign key ('
  ||&&sqllib..column_list(c.owner, c.constraint_name, 'CONSTRAINT')
  ||') references '||c2.owner||'.'||c2.table_name||' ('
  ||&&sqllib..column_list(c.r_owner, c.r_constraint_name, 'CONSTRAINT')||')'
  ||decode(c.delete_rule,'CASCADE',' ON DELETE CASCADE','')
  constraint_text
from &&ora._constraints c, &&ora._constraints c2
where c.constraint_type='R'
and c.r_owner=c2.owner
and c.r_constraint_name=c2.constraint_name
and c.owner like &&o2
and c.table_name like &&n2
and c2.owner like &&o1
and c2.table_name like &&n1
) loop
  sys.dbms_output.put_line(r.constraint_text);

  delete from saved_constraints
  where owner=r.owner
  and constraint_name=r.constraint_name;

  insert into saved_constraints
  (owner,constraint_name,constraint_type,table_name,
   r_owner,r_constraint_name,r_table_name,
   delete_rule,status,constraint_text)
  values
  (r.owner,r.constraint_name,r.constraint_type,r.table_name,
   r.r_owner,r.r_constraint_name,r.r_table_name,
   r.delete_rule,r.status,r.constraint_text);

  i:=i+1;
end loop;
sys.dbms_output.put_line(to_char(i)||' constraint(s) saved.');
end;
/

@setdefs.sql

