rem Author:  Mark Lang, 1998
rem Name:    segs.sql
rem Purpose: List segments
rem Usage:   @segs <%owner.segment_name%> <%type%> <%tablespace%>
rem Subject: space
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso:
rem History:
rem          01-feb-98  Initial release

@setup1
define ty="upper('&&2')"
define ts="upper('&&3')"

column sname 		format a19 heading "SEGMENT NAME"
column segment_type 	format a10 heading "TYPE"
column tablespace_name	format a12 heading "TABLESPACE"
column sizein		format a5  heading "INITL"
column sizenx		format a5  heading "NEXT"
column pct_incr  	format a4  heading "%INC"
column exts		format a7  heading "EXT/MAX"
column extfree		format a4  heading "EXT%"
column sizebl		format a5  heading "SIZE"

select
  &&segown||'.'||s.segment_name sname,
  s.segment_type,
  s.tablespace_name,
  decode(trunc(s.initial_extent/(1024*1024)), 0,
    to_char(s.initial_extent/1024, '990')||'k',
    to_char(s.initial_extent/(1024*1024), '990')||'M') sizein,
  decode(trunc(s.next_extent/(1024*1024)), 0,
    to_char(s.next_extent/1024, '990')||'k',
    to_char(s.next_extent/(1024*1024), '990')||'M') sizenx,
  ltrim(to_char(s.pct_increase, '990'))||'%' pct_incr,
  ltrim(to_char(s.extents, '990'))||'/'||
    ltrim(to_char(s.max_extents, '990')) exts,
  ltrim(to_char(s.extents/decode(s.max_extents, null, 121, 0, 121,
    s.max_extents)*100, '990'))||'%' extfree,
  ltrim(decode(trunc(s.bytes/(1024*1024)), 0,
    to_char(s.bytes/1024, '9990')||'k',
    decode(trunc(s.bytes/(10*1024*1024)), 0,
      to_char(s.bytes/(1024*1024), '90.9')||'M',
      to_char(s.bytes/(1024*1024), '9990')||'M')))
    sizebl
from &oru._segments s
where &&segown like &&o1
and s.segment_name like &&n1
and s.segment_type like &&ty
and s.tablespace_name like &&ts
order by &&segown, s.segment_name;

undef ts ty

@setdefs


