rem Author:  Mark Lang, 1998
rem Name:    segs2.sql
rem Purpose: List segments grouped by segment type
rem Usage:   @segs2 <%owner.segment_name%> <%type%> <%tablespace%> 
rem Descr:
rem Subject: space
rem Attrib:
rem Descr: 
rem Notes:
rem SeeAlso: @segs
rem History:
rem          01-feb-98  Initial release

@setup1

define typ="upper('&&2')"
define tsp="upper('&&3')"

column owner		format a15 heading "OWNER"
column segment_type 	format a10 heading "TYPE"
column tablespace_name	format a12 heading "TABLESPACE"
column cntsegs		format 9990 heading "SEGS"
column avgexts		format 90.9  heading "AVGEXT"
column maxexts		format 9990  heading "MAXEXT"
column sumblks		format 999,990 heading "BLOKS"
column sumbyts   	format 9,999,990 heading "KBYTES"

select
&&segown owner
,s.segment_type
,s.tablespace_name
,count(*) cntsegs
,avg(s.extents) avgexts
,max(s.extents) maxexts
,sum(s.blocks) sumblks
,sum(s.bytes/1024) sumbyts
from &&oru._segments s
where &&segown like &&o1
and s.segment_name like &&n1
and s.segment_type like &&typ
and s.tablespace_name like &&tsp
group by &&segown,s.segment_type,s.tablespace_name
;

undef typ tsp

@setdefs
