rem Author:  Mark Lang, 1998
rem Name:    segsi.sql
rem Purpose: List segments for indexes on selected tables
rem Usage:   @segsi <%owner.segment_name%> <%tablespace%>
rem Subject: space:segment:index
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @segs
rem History:

@setup1
define ts="upper('&&2')"

column sname 		format a19 heading "SEGMENT NAME"
column segment_type 	format a10 heading "TYPE"
column tablespace_name	format a12 heading "TABLESPACE"
column sizein		format a5  heading "INITL"
column sizenx		format a5  heading "NEXT"
column pct_incr  	format a4  heading "%INC"
column exts		format a7  heading "EXT/MAX"
column extfree		format a4  heading "EXT%"
column sizebl		format a5  heading "SIZE"

column blocksize new_value bs
set termout off
select blocksize from sys.ts$ where rownum < 2;
set termout on

select
  &&segown||'.'||s.segment_name sname,
  s.segment_type,
  s.tablespace_name,
  decode(trunc(s.initial_extent/(1024*1024)), 0,
    to_char(s.initial_extent/1024, '990')||'k',
    to_char(s.initial_extent/(1024*1024), '990')||'M') sizein,
  decode(trunc(s.next_extent/(1024*1024)), 0,
    to_char(s.next_extent/1024, '990')||'k',
    to_char(s.next_extent/(1024*1024), '990')||'M') sizenx,
  ltrim(to_char(s.pct_increase, '990'))||'%' pct_incr,
  ltrim(to_char(s.extents, '990'))||'/'||
    ltrim(to_char(s.max_extents, '990')) exts,
  ltrim(to_char(s.extents/decode(s.max_extents, null, 121, 0, 121,
    s.max_extents)*100, '990'))||'%' extfree,
  ltrim(decode(trunc(s.bytes/(1024*1024)), 0,
    to_char(s.bytes/1024, '9990')||'k',
    decode(trunc(s.bytes/(10*1024*1024)), 0,
      to_char(s.bytes/(1024*1024), '90.9')||'M',
      to_char(s.bytes/(1024*1024), '9990')||'M')))
    sizebl
from &oru._segments s, &&oru._indexes i
where i.table_owner like &&o1
and i.table_name like &&n1
and &&indown like &&o1
and &&segown=&&indown
and s.segment_name=i.index_name
and s.segment_type = 'INDEX'
and s.tablespace_name like &&ts
order by &&segown, s.segment_name;

undef ts

@setdefs


