rem Author:  Mark Lang, 1998
rem Name:    sess.sql
rem Purpose: Show users session information
rem Usage:   @sess <%username%> <%status%>
rem Subject: session
rem Attrib:  sql dba
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @users @who
rem History:
rem          01-feb-98  Initial release

@setup
define db=""
define usr="upper('&&1')"
define sts="upper('&&2')"

column username format a12
column sid      format a8
column serv_c   format a1 HEADING "S"
column disp     format a4
column circ_c   format a1 HEADING "C"
column pid      format a9 
column program  format a32 WRAP
column status	format a5 heading "STAT" trunc

select
  s.username,
  s.sid||','||s.serial# sid,
  substr(s.server, 1, 1) serv_c,
  d.name disp,
  substr(c.status, 1, 1) circ_c,
  s.process pid,
  s.program program,
  s.status
from v$session&&db s, v$circuit&&db c, v$dispatcher&&db d
where s.username is not null
and (
  s.username like &&usr
  or s.program like &&usr
  or d.name like &&usr
)
and s.saddr = c.saddr(+)
and c.dispatcher = d.paddr(+)
and s.status like &&sts
/*
union
select
  s.username,
  s.sid||','||s.serial#,
  substr(s.server, 1, 1) serv_c,
  NULL,
  NULL,
  s.process pid,
  s.program program,
  s.status
from v$session&&db s
where s.username is not null
and (s.username like &&usr
     or s.program like &&usr
    )
and not exists (
         select 0
         from v$circuit
         where saddr = s.saddr
)
*/
order by 1,2
;

undef db usr sts

@setdefs
