rem Author:  Mark Lang, 1998
rem Name:    sessio.sql
rem Purpose: Display IO and hit ratio by session
rem Usage:   @sessio <%user%> <%|S|U|A>
rem Subject: tuning
rem Attrib:  sql dba
rem Descr:
rem Notes:
rem SeeAlso: @hits @sess @stats
rem History:
rem          01-feb-98  Initial release

@setup

define db=""
define usr="upper('&&1')"
define arg="upper(replace('&&2','%','S'))"

column username format a15
column sid format 9,990 heading "SID"
column logical_reads format 9,999,990 heading "LOGRD"
column physical_reads format 9,999,990 heading "PHYRD"
column block_changes format 9,999,990 heading "BLKCHG"
column consistent_changes format 9,990 heading "CONCHG"
column hit_ratio format 0.999 heading "HIT%"
column wri_ratio format 0.999 heading "WRI%"

set heading off
select
  'SESSION IO FOR DATABASE - '||name
from v$database&&db
;
set heading on

select
  decode(&&arg, 'A', 'TOTAL', max(s.username)) username,
  decode(&&arg, 'U', count(*), 'A', count(*), max(i.sid)) sid,
  sum(i.block_gets+i.consistent_gets) logical_reads,
  sum(i.physical_reads) physical_reads,
  sum(i.block_changes) block_changes,
  sum(i.consistent_changes) consistent_changes,
  1-sum(i.physical_reads)/sum(i.block_gets+i.consistent_gets+1) hit_ratio,
  sum(i.block_changes)/sum(i.block_gets+i.consistent_gets+1) wri_ratio
from v$sess_io&&db i, v$session&&db s
where i.sid = s.sid
and s.type = 'USER'
and s.username is not null
group by decode(&&arg, 'U', s.username, 'A', 1, i.sid)
order by 7, 1, 2
;

undef db usr arg

@setdefs


