rem Author:  Mark Lang, 1998
rem Name:    setpq.sql
rem Purpose: Set PARALLEL characteristics of tables
rem Usage:   @setpq <%owner.table%> <degree|D|*> <instances|D|*>
rem Subject: object:table
rem Attrib:  sql gen ddl
rem Descr:
rem Notes:   * means do not modify
rem SeeAlso:
rem History:

@setup1
set heading off
define deg="upper('&&2')"
define ins="upper('&&3')"

spool setpq.tmp
select
  'alter table '||owner||'.'||table_name||&&cr||
  'parallel ('||
  decode(&&deg, 'D', 'degree default ', '*', '', 'degree '||&&deg||' ')||
  decode(&&ins, 'D', 'instances default ', '*', '', 'instance '||&&ins||' ')||
  ');'
from &&ora._tables t
where (&&deg<>'*' or &&ins<>'*')
and owner like &&o1
and table_name like &&n1
order by owner, table_name
;

spool off
@doit
set feedback on
@setpq.tmp

undef deg ins

@setdefs


