rem Author:  Mark Lang, 1998
rem Name:    sh.sql
rem Purpose: Calulates size of Shared Pool based on # of users
rem Usage:   @sh <# of users>
rem Subject: tuning
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @sga
rem History:
rem           01-feb-98 Initial release

@setup
set heading off

prompt Calulates size of Shared Pool based on # of users
prompt

var n_a number
var n_b number
var n_c number

begin
  select
    avg(value)*&&1 into :n_a
  from v$sesstat s, v$statname n
  where s.statistic# = n.statistic#
  and n.name = 'session uga memory max';

  select
    sum(sharable_mem) into :n_b
  from v$sqlarea;

  select
    sum(sharable_mem) into :n_c
  from v$db_object_cache;
end;
/

select
  'Recommeded size of shared pool: '||
    to_char((:n_a+:n_b+:n_c + (:n_a+:n_b+:n_c)*0.3)/(1024*1024), '990.99')||'M'
from sys.dual;

@setdefs
