rem Author:  Mark Lang, 1998
rem Name:    short.sql
rem Purpose: Display object represented by short name
rem Usage:   @short <short_name>
rem Subject: object
rem Attrib:  sql
rem Descr:
rem Notes:   Must follow naming convention for primary key
rem          <short>_PK or PK_<short>
rem          Table must currently have primary key
rem SeeAlso: @cons
rem History:
rem          01-feb-98 Initial release

@setup

define short="upper('&&1')"

select
owner
,table_name
from &&ora._constraints
where owner = substr(&&short,1,3)
and (
  constraint_name = &&short||'_PK'
  or constraint_name = 'PK'_&&short
)
and constraint_type = 'P'
;

undef short

@setdefs

