rem Author:  Mark Lang, 1998
rem Name:    spacemap.sql
rem Purpose: Display map of tablespace fragmentation
rem Usage:   @spacemap <tablespace> <%type%>
rem Subject: space
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @frag
rem History:
rem          01-feb-98 Initial release


@setup
define ts="upper('&&1')"
define ty="upper('&&2')"
define free="'< Free >'"

column tablespace_name format a12 heading "TABLESPACE"
column file_id format 99 heading "F#"
column segment_name format a25
column segment_type format a12
column extent_id format 990 heading "EXT#"
column block_id format 9,999,999
column blocks format 999,999
column kbytes format 999,999

select
  tablespace_name,
  file_id,
  owner||'.'||segment_name segment_name,
  segment_type,
  extent_id,
  block_id,
  blocks
from sys.dba_extents
where tablespace_name like &&ts
and segment_type like &&ty
union all
select
  tablespace_name,
  file_id,
  '< Free >',
  'UNUSED',
  1,
  block_id,
  blocks
from sys.dba_free_space
where tablespace_name like &&ts
and 'UNUSED' like &&ty
order by 1,2,6
;

undef ts ty free

@setdefs

