rem Author:  Mark Lang, 1998
rem Name:    sroles.sql
rem Purpose: Display SESSION_ROLES view
rem Usage:   @sroles <%role%>
rem Subject: user
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @privs @roles @whoami
rem History:
rem          09-feb-98  Created

@setup
define rol="upper('&&1')"

column role format a30 heading "ROLE"
column enabled format a3 heading "ENA"
column admin_option format a3 heading "ADM"
column default_role format a3 heading "DEF"
column os_granted format a3 heading "OS"

select sr.role, 'YES' enabled, ur.admin_option
, ur.default_role, ur.os_granted
from session_roles sr, user_role_privs ur
where sr.role like &&rol
and sr.role = ur.granted_role(+)
union all
select ur.granted_role, 'NO' enabled, ur.admin_option
, ur.default_role, ur.os_granted
from user_role_privs ur
where not exists (
  select 0
  from session_roles
  where role = ur.granted_role
)
order by 1;

undef rol

@setdefs
