rem Author:  Mark Lang, 1998
rem Name:    srows.sql
rem Purpose: Display table row(s) in tabular format
rem Usage:   @srows <owner.table> <where_clause>
rem Subject: database
rem Attrib:  sql gen
rem Descr:
rem Notes:
rem SeeAlso:
rem History:
rem          16-feb-98  Display only printable column types
rem          01-feb-98  Initial release

@setup1
set serveroutput on size 10240
set recsep each
set termout off
column text format a79 word

spool srows.tmp

declare
  s varchar2(128);
begin
dbms_output.put_line('prompt DISPLAY ROW FOR "&&1" WHERE "&&2"');
--dbms_output.put_line('prompt '||rpad('-',60,'-'));
dbms_output.new_line;
dbms_output.put_line('select');
for r in (
select *
from sys.dba_tab_columns
where owner=&&o1
and table_name=&&n1
and data_type in ('VARCHAR2','CHAR','DATE','NUMBER')
order by column_id
) loop
  if r.column_id > 1 then s := '||chr(10)||'; else s := ''; end if;
  s := s||'rpad('''||r.column_name||''',31)||';
  if r.data_type in ('VARCHAR2','CHAR') then
    s := s||r.column_name;
  else
    s := s||'to_char('||r.column_name||')';
  end if;
  dbms_output.put_line(s);
end loop;
dbms_output.put_line(' text');
dbms_output.put_line('from &&1');
dbms_output.put_line('where &&2;');
end;
/
spool off
set termout on
set recsep wrap
@srows.tmp
@setdefs

