rem Author:  Mark Lang, 1998
rem Name:    syncpwd.sql
rem Purpose: Synchronize user PASSWORDs between databases
rem Usage:   @syncpwd <database> <%users%> <%has_role%>
rem Subject: security
rem Attrib:  sql gen ddl dba
rem Descr:
rem Notes:   - Does not effect SYS
rem	     - Does not create or drop USERS
rem SeeAlso: @users
rem History:
rem          01-feb-98 Initial release

@setup
set heading off

define db="&&1"
define us="upper('&&2')"
define rl="upper('&&3')"

spool syncpwd.tmp

select
  'alter user '||u1.username||
  ' identified by values '''||u2.password||''';'
from sys.dba_users u1, sys.dba_users@&&db u2
where u1.username <> 'SYS'
and u1.username like &&us
and (
  &&rl='%'
  or exists (
    select 0
    from sys.dba_role_privs
    where grantee=u1.username
    and granted_role like &&rl
  )
)
and u1.username = u2.username
and u1.password <> u2.password
;

spool off

@doit
set feedback on
@syncpwd.tmp

undef db us rl

@setdefs





