rem Author:  Mark Lang, 1998
rem Name:    tabs.sql
rem Purpose: List tables
rem Usage:   @tabs <%owner.table%> <%ts%>
rem Subject: object:table
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @cons @idxs @objs @tabstat
rem History:
rem          01-feb-98  Initial release

@setup1
define ts="upper('&&2')"

column tname format a25 heading "TABLE_NAME"
column tablespace_name format a15 heading "TABLESPACE"
column pctfu format a6
column trans format a6
column pct_increase format 990 heading "%INC"
column degree format a5
column instances forma5
column cache format a1

select
  owner||'.'||table_name||' '||
  decode(cluster_name, NULL, '', &&cr||'(in '||
    cluster_name||')') tname,
  tablespace_name,
  ltrim(to_char(pct_free))||'/'||ltrim(to_char(pct_used)) pctfu,
  ltrim(to_char(ini_trans))||'/'||ltrim(to_char(max_trans)) trans,
  backed_up,
  lpad(ltrim(degree),5) degree,
  lpad(ltrim(instances),5) instances,
  ltrim(cache) cache
from &&ora._tables t
where owner like &&o1
and table_name like &&n1
and (tablespace_name like &&ts or tablespace_name is null)
order by owner, table_name
;

undef ts

@setdefs
