rem Author:  Mark Lang, 1998
rem Name:    trigs.sql
rem Purpose: List triggers
rem Usage:   @triggers <%owner.table%> <%type%>
rem Subject: object:table:trigger
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso:
rem History:
rem          29-apr-98  Show trigger owner if different from table owner
rem          01-feb-98  Initial release


@setup1

column tname  format a30 heading "NAME"
column tdesc  format a40 heading "TRIGGER" word
column status format a8  heading "STATUS"

select
  t.table_owner||'.'||t.table_name||'.'||decode(t.owner, t.table_owner, ''
    , '('||t.owner||').')||
    t.trigger_name tname,
  'TRIGGER ON '||t.triggering_event||' '||t.trigger_type tdesc,
  status
from &&ora._triggers t
where t.table_owner like &&o1
and t.table_name like &&n1
and 'TRIGGER ON '||t.triggering_event||' '||t.trigger_type LIKE UPPER('&&2')
order by 1
;

@setdefs
