rem Author:  Mark Lang, 1998
rem Name:    ts.sql
rem Purpose: List tablespaces
rem Usage:   @ts
rem Subject: database
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @frag
rem History:

@setup

define ts="upper('&&1')"

column tablespace_name format a15 heading "TABLESPACE"
column initial_extent format 999,990 heading "INITIAL-K"
column next_extent format 999,990 heading "NEXT-K"
column pct_increase format 990 heading "%INC"
column min_extents format 990 heading "MIN"
column max_extents format 990 heading "MAX"

select
  tablespace_name,
  initial_extent/1024 initial_extent,
  next_extent/1024 next_extent,
  min_extents,
  max_extents,
  pct_increase,
  status
from sys.dba_tablespaces
where tablespace_name like &&ts
order by tablespace_name
;

undef ts

@setdefs
