rem Author:  Mark Lang, 1998
rem Name:    uga.sql
rem Purpose: Display user UGA memory usage
rem Usage:   @uga <%user%> <%|minuga>
rem Subject: tuning:memory
rem Attrib:  sql
rem Descr:
rem Notes:
rem SeeAlso: @stats @uga
rem History:
rem          01-feb-98  Initial release

@setup

define usr="upper('&&1')"
define min="to_number(decode('&&2','%','0','&&2'))"

column username format a20
column uga format 999,999,990 heading "UGA"
column umx format 999,999,990 heading "UGA MAX"
column pct format 0.990 heading "%MAX"

select
  s.username
, tuga.value uga
, tumx.value umx
, tuga.value/tumx.value pct
from v$session s
, v$sesstat  tuga
, v$statname nuga
, v$sesstat  tumx
, v$statname numx
where s.username like &&usr
and tuga.sid = s.sid and tuga.statistic# = nuga.statistic# and nuga.name = 'session uga memory'
and tumx.sid = s.sid and tumx.statistic# = numx.statistic# and numx.name = 'session uga memory max'
and tuga.value >= &&min
order by decode(&&min, 0, s.username, lpad(tuga.value, 15))
;

undef usr min

@setdefs
