rem Author:  Mark Lang, 1998
rem Name:    updcols.sql
rem Purpose: Display updatable columns in join views
rem Usage:   @updcols <%owner.view%> <%column%>
rem Subject: object:view
rem Attrib:  sql v72
rem Descr:
rem Notes:
rem SeeAlso: @cols
rem History:
rem          01-feb-98  Initial release


@setup1
define col="upper('&&2')"

column tname format a30
column column_name format a25
column updatable format a3

select
  owner||'.'||table_name tname,
  column_name,
  updatable
from &&ora._updatable_columns
where owner like &&o1
and table_name like &&n1
and column_name like &&col
order by owner,table_name,column_name
;

undef col

@setdefs

