rem Author:  Mark Lang, 1998
rem Name:    userenv.sql
rem Purpose: Show values of all USERENV variables
rem Usage:   @userenv
rem Subject: user
rem Attrib:  sql v73
rem Descr:
rem Notes:   Valid USERENV parameters are:
rem          OSDBA, LABEL*, LANGUAGE, TERMINAL, SESSIONID*, ENTRYID*
rem          CLIENT_INFO, LANG
rem          *restricted, see documentation
rem          SESSIONID,ENTRYID require AUDIT_TRAIL=TRUE in init.ora
rem SeeAlso:
rem History:
rem          03-feb-98  Created

@setup

column env format a15
column value format a40

select 'LANGUAGE' env, userenv('LANGUAGE') value from sys.dual
union all
select 'TERMINAL' env, userenv('TERMINAL') value from sys.dual
union all
select 'SESSIONID' env, to_char(userenv('SESSIONID')) value from sys.dual
union all
select 'ENTRYID' env, to_char(userenv('ENTRYID')) value from sys.dual
union all
select 'CLIENT_INFO' env, userenv('CLIENT_INFO') value from sys.dual
union all
select 'LANG' env, userenv('LANG') value from sys.dual
;

undef env
undef value

@setdefs
