rem Author:  Mark Lang, 1998
rem Name:    users.sql
rem Purpose: This script displays users accounts (granted listed roles)
rem Usage:   @users <%username%> <%role%>
rem Subject: user
rem Attrib:  sql dba
rem Descr:
rem Notes:
rem SeeAlso: @roles
rem History:
rem          01-feb-98  Initial release

@setup

column username format a20
column default_tablespace format a15 heading "DEFAULT"
column temporary_tablespace format a15 heading "TEMPORARY"
column profile format a15

select
  u.username,
  u.default_tablespace,
  u.temporary_tablespace,
  u.created,
  u.profile
from sys.dba_users u
where u.username like upper('&&1')
and (
  upper('&&2') in ('*', '%')
  or exists (
/*
      SELECT *
      FROM sys.dba_role_privs
      WHERE grantee = u.username
      AND granted_role LIKE UPPER('&&2')
*/
    select 0
    from sys.sysauth$ sa, sys.user$ r
    where sa.grantee#=u.user_id
    and sa.privilege#=r.user#
    and r.name like upper('&&2')
  )
)
order by u.username
;

@setdefs
